<?php

namespace alldevs\IfocopBundle\Controller\Facture;

use Admingenerated\alldevsIfocopBundle\BaseFactureController\EditController as BaseEditController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\RedirectResponse;

class EditController extends BaseEditController
{
    public function updateAction($pk)
    {
        $Facture = $this->getObject($pk);
        if (!$Facture) {
            throw new NotFoundHttpException("The alldevs\IfocopBundle\Entity\Facture with id $pk can't be found");
        }

        $this->preBindRequest($Facture);
        $form = $this->createForm($this->getEditType(), $Facture);
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $Facture);
                $this->saveObject($Facture);
                $this->postSave($form, $Facture);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                
                if($this->get('request')->request->has('imprimer')){
                    return $this->choixadresseFacture($Facture);
                }
                
                if($this->get('request')->request->has('save-and-add'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Facture_new" ));
                if($this->get('request')->request->has('save-and-list'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Facture_list" ));
                else
                  return $this->getReturnFunction($pk);
            } catch (\Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Facture);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('alldevsIfocopBundle:FactureEdit:index.html.twig', $this->getAdditionalRenderParameters($Facture) + array(
            "Facture" => $Facture,
            "form" => $form->createView(),
        ));
    }
    
    public function choixadresseFacture($Facture){
        return $this->render('alldevsIfocopBundle:FactureEdit:choixadresse.html.twig', array(
            "Facture" => $Facture
        ));
    }
}
