<?php

namespace alldevs\IfocopBundle\Controller\Facture;

use Admingenerated\alldevsIfocopBundle\BaseFactureController\ListController as BaseListController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;


class ListController extends BaseListController
{
    public function indexAction()
    {
        

        if ($this->get('request')->query->get('page'))
        {
          $this->setPage($this->get('request')->query->get('page'));
        }

        if ($this->get('request')->query->get('sort'))
        {
          $this->setSort($this->get('request')->query->get('sort'), $this->get('request')->query->get('order_by','ASC'));
        }

        $form = $this->getFilterForm();
        $cmd=$this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:Facture');
        $names=$cmd->getAssociationNames();
        $assocs=array();
        foreach ($names as $name)
        {
            if (!$cmd->isCollectionValuedAssociation($name))
            {   
                $tab=explode('\\',$cmd->getAssociationTargetClass($name));
                $assname=$tab[count($tab)-1];
                $meta = $this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:'.$assname);
                $identifier = $meta->getSingleIdentifierFieldName();
                $assocs[$name]=array("field"=>$assname,"refid"=>$identifier);
            }
        }
        $multiids=array();
        if ($this->get('request')->query->has('isMulti') && $this->get('request')->query->get('motherid')!='')
        {
            $reprel = $this->getDoctrine()->getRepository('alldevsIfocopBundle:'.$this->get('request')->query->get('motherentity'));
            $relobj=$reprel->find($this->get('request')->query->get('motherid'));  

            $pos=strpos($this->get('request')->query->get('class'),":");
            $getter="getId".substr($this->get('request')->query->get('class'),$pos+1);
            foreach ($relobj->$getter() as $stg)
            {
                $multiids[]=$stg->getId();
            }
        }
        
        $em=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Facture')->findAll();
        $isFacture=array();
        foreach ($em as $id)
        {
           $pdffile=$this->container->get('kernel')->getRootDir()."/../uploads/facture/".$id->getId().".pdf";
           if (file_exists($pdffile)){
               $isFacture[$id->getId()]=1;
           }else{
               $isFacture[$id->getId()]=0;
           }
        }
       // var_dump($isFacture);
       // exit;
        
        return $this->render('alldevsIfocopBundle:FactureList:index.html.twig', $this->getAdditionalRenderParameters() + array(
            'Factures' => $this->getPager(),
            'form'                      => $form->createView(),
            'sortColumn'                => $this->getSortColumn(),
            'sortOrder'                 => $this->getSortOrder(),
            'scopes'                    => $this->getScopes(),
            'assocs'                  => $assocs,
            'isSelect'   =>  $this->get('request')->query->has('isSelect'),
            'isMulti'   =>  $this->get('request')->query->has('isMulti'),
            'multiids' => $multiids,
            'isFacture' => $isFacture
        ));
    }
    public function buildQuery() {
        $securityContext = $this->container->get('security.context');
        $myuser=$securityContext->getToken()->getUser();
        $session_filters=$this->getRequest()->getSession()->get('alldevs\IfocopBundle\FactureList\Filters');
        $q = parent::buildQuery();
        if ($securityContext->isGranted('ROLE_CENTRE')) {
            $q->innerJoin("q.idPrises", "p")->innerJoin("p.idStagiaires", "s")->innerJoin("s.idGroupes", "g")->innerJoin("g.idCentres", "c")->andWhere("c.id=".$this->getRequest()->getSession()->get("centre")->getId()."");
            if(isset($session_filters['OrgaPrises']) && $session_filters['OrgaPrises']!=NULL){
                $q->innerJoin("p.idOrganismes", "org")->andWhere("org.id=".$session_filters['OrgaPrises']."");
            }
        }else{
            if(isset($session_filters['OrgaPrises']) && $session_filters['OrgaPrises']!=NULL){
                $q->innerJoin("q.idPrises", "p")->innerJoin("p.idOrganismes", "org")->andWhere("org.id=".$session_filters['OrgaPrises']."");
            }
        }
        
        return $q;
    }
 
    /**
     * Store in the session service the current filters
     *
     * @param array the filters
     */
    protected function setFilters($filters)
    {

        if (isset($filters['idGroupes'])) {
                $filters['idGroupes'] = array (
                    'id' => $filters['idGroupes']->getId(),
                    'entityName' => get_class($filters['idGroupes'])
                );
        }
        if (isset($filters['idStagiaires'])) {
                $filters['idStagiaires'] = array (
                    'id' => $filters['idStagiaires']->getId(),
                    'entityName' => get_class($filters['idStagiaires'])
                );
        }
        $add_data_orga=$this->getRequest()->request->get('filters_facture');
        $filters['OrgaPrises']=$add_data_orga['OrgaPrises'];
        $this->get('session')->set('alldevs\IfocopBundle\FactureList\Filters', $filters);
    }

    public function factureAction($pk)
    {
            $facture=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Facture')->find($pk); 
            return $this->render('alldevsIfocopBundle:FactureEdit:choixadresse.html.twig', array(
                "Facture" => $facture
            ));
    }
    public function showfactureAction($pk){
        $pdffile=$this->container->get('kernel')->getRootDir()."/../uploads/facture/".$pk.".pdf";
        return $this->makeResponse($pdffile);
    }
    public function imprimerAction(Request $request)
    {
        $id=$request->get("pk");
        if($request->get('option')==0){
            return $this->generateFacture($id,$request->get('option'));
        }
        if($request->get('option')==1){
            return $this->generateFacture($id,$request->get('option'));
        }
        if($request->get('option')==2){
            $ligne1=$request->get('destinataire');
            $ligne2=$request->get('adrcomplement');
            $ligne3=$request->get('adrrue');
            $ligne4=$request->get('adrcp');
            $ligne5=$request->get('adrville');
            $ligne6=$request->get('adrbp');
            
            return $this->generateFacture($id,$request->get('option'),$ligne1,$ligne2,$ligne3,$ligne4,$ligne5,$ligne6);
        }
    }
    
    public function generateFacture($pk,$option,$ligne1=NULL,$ligne2=NULL,$ligne3=NULL,$ligne4=NULL,$ligne6=NULL,$ligne6=NULL)
    {
        $html2pdf = $this->get('html2pdf')->get();
        $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/facture.html";
        $image=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/images/logo_ifocop.png";

        $facture=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Facture')->find($pk); 
        $banque=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Banquescentre')->findOneByBanquefacture(1);
            $centre=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getLib();
            $centre_rue=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getAdrrue();
            $centre_cp=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getAdrcp();
            $centre_ville=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getAdrville();
            $centre_tel=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getTelephone();
            $centre_fax=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getFax();
            $centre_email=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getEmail();
            $vos_references=$facture->getReference().' '.$facture->getIdPrises()->getReference();

        /*$securityContext = $this->container->get('security.context');
        if ($securityContext->isGranted('ROLE_CENTRE')) {
            $centre=$this->getRequest()->getSession()->get("centre")->getLib();
        }else{
            $centre="Rungis";
        }*/
        
        setlocale (LC_TIME, 'fr_FR.utf8','fra');
        $datedujour=(strftime("%d %B %Y"));
        $content = "<page backtop=\"0mm\" backbottom=\"0mm\" backleft=\"5mm\" backright=\"5mm\">".file_get_contents($template)."</page>";
        $content = str_replace("##Reference##",$vos_references,$content);
        $content = str_replace("##Vos_Reference##",$facture->getVosrefs(),$content);                
        $content = str_replace("##Num_Facture##",$facture->getNumfacture(),$content);
        $content = str_replace("##CENTRE##",$centre,$content);   
        $content = str_replace("##CENTRE_RUE##",$centre_rue,$content); 
        $content = str_replace("##CENTRE_CP##",$centre_cp,$content); 
        $content = str_replace("##CENTRE_VILLE##",$centre_ville,$content); 
        $content = str_replace("##CENTRE_TEL##",$centre_tel,$content); 
        $content = str_replace("##CENTRE_FAX##",$centre_fax,$content); 
        $content = str_replace("##CENTRE_EMAIL##",$centre_email,$content); 
        $content = str_replace("##Nbre_Effectue##",$facture->getIdprises()->getNbrheure(),$content);          
        $content = str_replace("##Cout##",number_format($facture->getIdPrises()->getMontant(),2,',',' '),$content);
        $content = str_replace("##Echeance##",$facture->getEcheance()->format("d/m/Y"),$content);
        $content = str_replace("##Date_JOUR##",$datedujour,$content);
        $content = str_replace("##Centre##",$centre,$content);
        
        $duree_prise="du ".$facture->getIdPrises()->getDateprise()->format("d/m/Y")." au ".$facture->getIdPrises()->getDateprisefin()->format("d/m/Y");
        $content = str_replace("##Duree##",$duree_prise,$content);
        $content = str_replace("##Module##",$facture->getIdPrises()->getDescription(),$content);
        $content = str_replace("##IDENT##",$facture->getIdPrises()->getIdentstagiaire(),$content);
        $content = str_replace("##Cout_horaire##",number_format($facture->getIdPrises()->getCoutheure(),2,',',' '),$content);
        
        if($facture->getIdStagiaires()){
                    $nom_stagiaires=$facture->getIdStagiaires()->getNom()." ".$facture->getIdStagiaires()->getPrenom();
                    $content = str_replace("##Code_Groupes##",$facture->getIdStagiaires()->getIdGroupes()->getCde(),$content); 
                    $content = str_replace("##Nom_Formation##",$facture->getIdStagiaires()->getIdFormations()->getLib(),$content);      
                    $content = str_replace("##Lieu##",$facture->getIdStagiaires()->getIdGroupes()->getIdCentres()->getLib(),$content);          
        }elseif($facture->getIdPrises()){
                    $nom_stagiaires=$facture->getIdPrises()->getIdStagiaires()->getNom()." ".$facture->getIdPrises()->getIdStagiaires()->getPrenom();
                    $content = str_replace("##Code_Groupes##",$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getCde(),$content); 
                    $content = str_replace("##Nom_Formation##",$facture->getIdPrises()->getIdStagiaires()->getIdFormations()->getLib(),$content);      
                    $content = str_replace("##Lieu##",$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getLib(),$content);
        }
        
        if($option==0){
                    $periode="du ".$facture->getIdPrises()->getDatedebut()->format("d/m/Y")." au ".$facture->getIdPrises()->getDatefin()->format("d/m/Y");
                    $content = str_replace("##Destinataire##",$facture->getIdPrises()->getIdOrganismes()->getLib(),$content);              
                    $content = str_replace("##Complement##",$facture->getIdPrises()->getIdOrganismes()->getLibcomp(),$content);
                    $content = str_replace("##Nom_Rue##",$facture->getIdPrises()->getIdOrganismes()->getAdrrue(),$content);        
                    $content = str_replace("##CP##",$facture->getIdPrises()->getIdOrganismes()->getAdrcp(),$content);        
                    $content = str_replace("##BP##",$facture->getIdPrises()->getIdOrganismes()->getAdrbp(),$content); 
                    $content = str_replace("##Villes##",$facture->getIdPrises()->getIdOrganismes()->getAdrville(),$content);  
        }
        if($option==1){
                    $periode="du ".$facture->getIdStagiaires()->getDatedebut()->format("d/m/Y")." au ".$facture->getIdStagiaires()->getDatefin()->format("d/m/Y");
                    $content = str_replace("##Destinataire##",$nom_stagiaires,$content);
                    $content = str_replace("##Complement##",'',$content);
                    $content = str_replace("##Nom_Rue##",$facture->getIdStagiaires()->getAdrrue(),$content);        
                    $content = str_replace("##CP##",$facture->getIdStagiaires()->getAdrcp(),$content);        
                    $content = str_replace("##BPt##",'',$content);
                    $content = str_replace("##Villes##",$facture->getIdStagiaires()->getAdrville(),$content);     
        }
        if($option==2){
                    $periode="du ".$facture->getIdStagiaires()->getDatedebut()->format("d/m/Y")." au ".$facture->getIdStagiaires()->getDatefin()->format("d/m/Y");
                    $content = str_replace("##Destinataire##",$ligne1,$content); 
                    $content = str_replace("##Ordre##",$ligne1,$content);
                    $content = str_replace("##Complement##",$ligne2,$content);
                    $content = str_replace("##Nom_Rue##",$ligne3,$content);        
                    $content = str_replace("##BP##",$ligne6,$content);
                    $content = str_replace("##CP##",$ligne4,$content);        
                    $content = str_replace("##Villes##",$ligne5,$content);    
        }
        $content = str_replace("##Stagiaire##",$nom_stagiaires,$content);
        $content = str_replace("##dom##",$banque->getDombanque(),$content);
        $content = str_replace("##banque##",$banque->getCdebanque(),$content);
        $content = str_replace("##guichet##",$banque->getCdeagence(),$content);
        $content = str_replace("##numcompte##",$banque->getNumcompte(),$content);
        $content = str_replace("##rib##",$banque->getClerib(),$content);
        $content = str_replace("##iban##",$banque->getIban(),$content);
        $content = str_replace("##Periode##",$periode,$content);   
        $content = str_replace("##Logo##",$image,$content);           


        $html2pdf->WriteHTML($content);
        
        $pdffile=$this->container->get('kernel')->getRootDir()."/../uploads/facture/".$pk.".pdf";
        
        $html2pdf->Output($pdffile, "F"); 
        
        $response=$this->makeResponse($pdffile,$facture->getNumfacture());
        
        return $response;
    } 
    
    public function makeResponse($pdffile)
    {
        $content_PDF=file_get_contents($pdffile);
                
        $response = new Response();


  
        // Set headers
        $response->headers->set('Pragma', 'public');
        $response->headers->set('Cache-Control', 'maxage=1');
        $response->headers->set('Content-type', 'application/pdf');
        $response->headers->set('ontent-Disposition', 'attachment; filename="facture.pdf"');

        // Send headers before outputting anything
        $response->sendHeaders();

        $response->setContent($content_PDF);   
        
        return $response;
    }
    
// relance --------------------------------------------------------------------------------------------- //
     public function relanceAction($pk)
    {
        $facture=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Facture')->find($pk); 
        return $this->render('alldevsIfocopBundle:FactureList:choixrelance.html.twig', array(
            "Facture" => $facture,
            "montant" => $facture->getMontant()
        ));
    }
    
    public function relancerAction(Request $request)
    {
        $id=$request->get("pk");

        if($request->get('option')==0){
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'));
        }
        if($request->get('option')==1){
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'));
        }
        if($request->get('option')==2){
            $ligne1=$request->get('destinataire');
            $ligne2=$request->get('adrcomplement');
            $ligne3=$request->get('adrrue');
            $ligne4=$request->get('adrcp');
            $ligne5=$request->get('adrville');
            $ligne6=$request->get('adrbp');
            
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'),$ligne1,$ligne2,$ligne3,$ligne4,$ligne5,$ligne6);
        }
    }
    
    public function generateRelance($pk,$option,$montant_relance,$type_relance,$ligne1=NULL,$ligne2=NULL,$ligne3=NULL,$ligne4=NULL,$ligne5=NULL,$ligne6=NULL)
    {
        $facture=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Facture')->find($pk); 
        $html2pdf = $this->get('html2pdf')->get();
        if($type_relance==1){
            $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/relance1.html";
            $centre=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getLib();
            $centre_rue=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getAdrrue();
            $centre_cp=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getAdrcp();
            $centre_ville=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getAdrville();
            $centre_tel=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getTelephone();
            $centre_fax=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getFax();
            $centre_email=$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()->getEmail();
        }else{
            $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/relance2.html";
            $centre_principal=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Centres')->findOneByPrincipal(1);
            $centre=$centre_principal->getLib();
            $centre_rue=$centre_principal->getAdrrue();
            $centre_cp=$centre_principal->getAdrcp();
            $centre_ville=$centre_principal->getAdrville();
            $centre_tel=$centre_principal->getTelephone();
            $centre_fax=$centre_principal->getFax();
            $centre_email=$centre_principal->getEmail();
        }
        $image=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/images/logo_ifocop.png";

        
        $nom_stagiaires=$facture->getIdPrises()->getIdStagiaires()->getNom()." ".$facture->getIdPrises()->getIdStagiaires()->getPrenom();
        $periode="du ".$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getDatedebut()->format("d/m/Y")." au ".$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y");
        setlocale (LC_TIME, 'fr_FR.utf8','fra');
        $datedujour=(strftime("%d %B %Y"));

        $content = "<page backtop=\"0mm\" backbottom=\"-15mm\" backleft=\"0mm\" backright=\"0mm\">".file_get_contents($template)."</page>";
        $content = str_replace("##FACTURE##",$facture->getNumfacture(),$content);         
        $content = str_replace("##CENTRE##",$centre,$content);   
        $content = str_replace("##CENTRE_RUE##",$centre_rue,$content); 
        $content = str_replace("##CENTRE_CP##",$centre_cp,$content); 
        $content = str_replace("##CENTRE_VILLE##",$centre_ville,$content); 
        $content = str_replace("##CENTRE_TEL##",$centre_tel,$content); 
        $content = str_replace("##CENTRE_FAX##",$centre_fax,$content); 
        $content = str_replace("##CENTRE_EMAIL##",$centre_email,$content); 
        $content = str_replace("##DATE_FACTURE##",$facture->getDatecreation()->format("d/m/Y"),$content);         
        $content = str_replace("##Reference##",$facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getCde(),$content);
        $content = str_replace("##Vos_Reference##",$nom_stagiaires,$content);         
        $content = str_replace("##Cout##",number_format($facture->getMontant(),2,',',' '),$content);
        $content = str_replace("##NOM_FORMATION##",$facture->getIdPrises()->getIdStagiaires()->getIdFormations()->getLib(),$content);
        $content = str_replace("##DATE_FORMATION##",$periode,$content);
        $content = str_replace("##Date_JOUR##",$datedujour,$content);
       // $content = str_replace("##Num_Cheque##",$facture->getNumcheque(),$content); 
        $content = str_replace("##COUT##",number_format($montant_relance,2,',',' '),$content); 
        if($option==0){
                    $content = str_replace("##Destinataire##",$facture->getIdPrises()->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Ordre##",$facture->getIdPrises()->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Complement##",$facture->getIdPrises()->getIdOrganismes()->getReference(),$content); 
                    $content = str_replace("##Nom_Rue##",$facture->getIdPrises()->getIdOrganismes()->getAdrrue(),$content);
                    $content = str_replace("##BP##",$facture->getIdPrises()->getIdOrganismes()->getAdrbp(),$content);
                    $content = str_replace("##CP##",$facture->getIdPrises()->getIdOrganismes()->getAdrcp(),$content);        
                    $content = str_replace("##Villes##",$facture->getIdPrises()->getIdOrganismes()->getAdrville(),$content);  
        }
        if($option==1){
                    $content = str_replace("##Destinataire##",$nom_stagiaires,$content);
                    $content = str_replace("##Ordre##",$nom_stagiaires,$content);
                    $content = str_replace("##Complement##",' ',$content);
                    $content = str_replace("##Nom_Rue##",$facture->getIdPrises()->getIdStagiaires()->getAdrrue(),$content);        
                    $content = str_replace("##BP##",' ',$content);
                    $content = str_replace("##CP##",$facture->getIdPrises()->getIdStagiaires()->getAdrcp(),$content);        
                    $content = str_replace("##Villes##",$facture->getIdPrises()->getIdStagiaires()->getAdrville(),$content);     
        }
        if($option==2){
                    $content = str_replace("##Destinataire##",$ligne1,$content); 
                    $content = str_replace("##Ordre##",$ligne1,$content);
                    $content = str_replace("##Complement##",$ligne2,$content);
                    $content = str_replace("##Nom_Rue##",$ligne3,$content);        
                    $content = str_replace("##BP##",$ligne6,$content);
                    $content = str_replace("##CP##",$ligne4,$content);        
                    $content = str_replace("##Villes##",$ligne5,$content);   
        }
        $content = str_replace("##Logo##",$image,$content);   


        $html2pdf->WriteHTML($content);
        $content_PDF = $html2pdf->Output('', true);  
        
        $response = new Response();

        // Set headers
        $response->headers->set('Cache-Control', 'private');
        $response->headers->set('Content-type', 'application/pdf');
        $response->headers->set('Content-Disposition', 'filename="relance.pdf"');

        // Send headers before outputting anything
        $response->sendHeaders();

        $response->setContent( $content_PDF);        
        return $response;
    } 

}
