<?php

namespace alldevs\IfocopBundle\Controller\Facture;

use Admingenerated\alldevsIfocopBundle\BaseFactureController\NewController as BaseNewController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;

class NewController extends BaseNewController
{
    public function preForm($Facture)
    {
        $Facture->setDatecreation(new \DateTime());
    }
    
    public function postSave(\Symfony\Component\Form\Form $form, \alldevs\IfocopBundle\Entity\Facture $Facture)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $Facture->setNumfacture(str_pad($Facture->getId(), 10, "0", STR_PAD_LEFT));
        if($Facture->getIdStagiaires()){
            $codegroupe=$Facture->getIdStagiaires()->getIdGroupes()->getCde();
        } elseif($Facture->getIdPrises()){
            $codegroupe=$Facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getCde();
        }
        $Facture->setReference($codegroupe);
        $Facture->setIdGroupes($Facture->getIdPrises()->getIdStagiaires()->getIdGroupes());
        $Facture->setIdCentres($Facture->getIdPrises()->getIdStagiaires()->getIdGroupes()->getIdCentres()); 
        $Facture->setIdStagiaires($Facture->getIdPrises()->getIdStagiaires());
        $Facture->setMontant($Facture->getIdPrises()->getMontant());
        $Facture->setNbreheure($Facture->getIdPrises()->getNbrheure());
        $em->persist($Facture);
        $em->flush();
        
        $em=$this->getDoctrine()->getEntityManager();
        $prises=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Prises')->find($Facture->getIdPrises()); 
        $prises->setValidation(1);
        $em->persist($prises);
        $em->flush();
    }
    
    public function createAction()
    {
        

        $Facture = $this->getNewObject();

        $this->preBindRequest($Facture);
        $form = $this->createForm($this->getNewType(), $Facture);
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $Facture);
                $this->saveObject($Facture);
                $this->postSave($form, $Facture);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                
                if($this->get('request')->request->has('imprimer')){
                    return $this->choixadresseFacture($Facture);
                }
                
                if($this->get('request')->request->has('save-and-add'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Facture_new" ));
                if($this->get('request')->request->has('save-and-list'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Facture_list" ));
                else
                  return $this->getReturnFunction($Facture);
            } catch (\Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Facture);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('alldevsIfocopBundle:FactureNew:index.html.twig', $this->getAdditionalRenderParameters($Facture) + array(
            "Facture" => $Facture,
            "form" => $form->createView(),
        ));
    }
    public function choixadresseFacture($Facture){
        return $this->render('alldevsIfocopBundle:FactureEdit:choixadresse.html.twig', array(
            "Facture" => $Facture
        ));
    }

    
}
