<?php

namespace alldevs\IfocopBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\EventDispatcher\EventDispatcher,
    Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken,
    Symfony\Component\Security\Http\Event\InteractiveLoginEvent;

class HomepageController extends Controller
{
    /**
     * @Route("/")
     * @Template()
     */
    public function indexAction() 
    {
              return $this->render('alldevsIfocopBundle:Homepage:index.html.twig', array());
    }
    
    public function forbiddenAction()
    {
              return $this->render('alldevsIfocopBundle:Homepage:forbidden.html.twig', array());
    }
    
    public function loginAction()
    {
        if ($_SESSION['access_token']==NULL)
        {
                  return $this->redirect( '/Authorize.php' ) ;
        }  
        $user=$this->getDoctrine()->getManager()->getRepository('alldevsIfocopBundle:MyUser')->findOneByUsername($_SESSION["Username"]);
        if ($user!=NULL)
        {

            $token = new UsernamePasswordToken($user, $user->getPassword(),
                                               "main", $user->getRoles());

            $this->get("security.context")->setToken($token);

            // Trigger login event
            $event = new InteractiveLoginEvent($this->getRequest(), $token);
            $this->get("event_dispatcher")
                 ->dispatch("security.interactive_login", $event); 

            return $this->redirect($this->generateUrl("AdmingeneratorDashboard_welcome"));
            
        }
        else
            return $this->render('alldevsIfocopBundle:Homepage:forbidden.html.twig', array());
    }

}
