<?php

namespace alldevs\IfocopBundle\Controller\Prises;

use Admingenerated\alldevsIfocopBundle\BasePrisesController\ListController as BaseListController;
use Exception;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

class ListController extends BaseListController
{
    public function indexAction()
    {
        if ($this->get('request')->query->get('page'))
        {
          $this->setPage($this->get('request')->query->get('page'));
        }

        if ($this->get('request')->query->get('sort'))
        {
          $this->setSort($this->get('request')->query->get('sort'), $this->get('request')->query->get('order_by','ASC'));
        }

        $form = $this->getFilterForm();
        $cmd=$this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:Prises');
        $names=$cmd->getAssociationNames();
        $assocs=array();
        foreach ($names as $name)
        {
            if (!$cmd->isCollectionValuedAssociation($name))
            {   
                $tab=explode('\\',$cmd->getAssociationTargetClass($name));
                $assname=$tab[count($tab)-1];
                $meta = $this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:'.$assname);
                $identifier = $meta->getSingleIdentifierFieldName();
                $assocs[$name]=array("field"=>$assname,"refid"=>$identifier);
            }
        }
        $multiids=array();
        if ($this->get('request')->query->has('isMulti') && $this->get('request')->query->get('motherid')!='')
        {
            $reprel = $this->getDoctrine()->getRepository('alldevsIfocopBundle:'.$this->get('request')->query->get('motherentity'));
            $relobj=$reprel->find($this->get('request')->query->get('motherid'));  

            $pos=strpos($this->get('request')->query->get('class'),":");
            $getter="getId".substr($this->get('request')->query->get('class'),$pos+1);
            foreach ($relobj->$getter() as $stg)
            {
                $multiids[]=$stg->getId();
            }
        }
        if($this->get('request')->query->has('isSelect')){
            
            
        }
        
        return $this->render('alldevsIfocopBundle:PrisesList:index.html.twig', $this->getAdditionalRenderParameters() + array(
            'Prisess' => $this->getPager(),
            'form'                      => $form->createView(),
            'sortColumn'                => $this->getSortColumn(),
            'sortOrder'                 => $this->getSortOrder(),
            'scopes'                    => $this->getScopes(),
            'assocs'                  => $assocs,
            'isSelect'   =>  $this->get('request')->query->has('isSelect'),
            'isMulti'   =>  $this->get('request')->query->has('isMulti'),
            'multiids' => $multiids,
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1) ,            
            'modale'=>($this->get('request')->get('modale')!=null?true:false)            
        ));
    }
    public function buildQuery() {
        $securityContext = $this->container->get('security.context');
        $myuser=$securityContext->getToken()->getUser();
        $q = parent::buildQuery();
        if ($securityContext->isGranted('ROLE_CENTRE')) {
            $q->innerJoin("q.idStagiaires", "s")->innerJoin("s.idGroupes", "g")->innerJoin("g.idCentres", "c")->andWhere("c.id=".$this->getRequest()->getSession()->get("centre")->getId()."");
        }
        if($this->get('request')->query->has('isSelect')){
            $q->andWhere("q.validation!=1");
        }
        return $q;
    }
    public function relanceAction($pk)
    {
        $prises=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Prises')->find($pk); 
        return $this->render('alldevsIfocopBundle:PrisesList:choixrelance.html.twig', array(
            "Prises" => $prises,
            "montant" => $prises->getMontant()
        ));
    }
    
    public function relancerAction(Request $request)
    {
        $id=$request->get("pk");

        if($request->get('option')==0){
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'));
        }
        if($request->get('option')==1){
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'));
        }
        if($request->get('option')==2){
            $ligne1=$request->get('destinataire');
            $ligne2=$request->get('adrcomplement');
            $ligne3=$request->get('adrrue');
            $ligne4=$request->get('adrcp');
            $ligne5=$request->get('adrville');
            $ligne6=$request->get('adrbp');
            
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'),$ligne1,$ligne2,$ligne3,$ligne4,$ligne5,$ligne6);
        }
    }
    
    public function generateRelance($pk,$option,$montant_relance,$type_relance,$ligne1=NULL,$ligne2=NULL,$ligne3=NULL,$ligne4=NULL,$ligne5=NULL,$ligne6=NULL)
    {
        $html2pdf = $this->get('html2pdf')->get();
        if($type_relance==1){
            $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/relance1.html";
        }else{
            $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/relance2.html";
        }
        $image=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/images/logo_ifocop.png";

        $prises=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Prises')->find($pk); 
        $nom_stagiaires=$prises->getIdStagiaires()->getNom()." ".$prises->getIdStagiaires()->getPrenom();
        $periode="du ".$prises->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y")." au ".$prises->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y");
        setlocale (LC_TIME, 'fr_FR.utf8','fra');
        $datedujour=(strftime("%A %d %B %Y"));

        $content = "<page backtop=\"0mm\" backbottom=\"-15mm\" backleft=\"0mm\" backright=\"0mm\">".file_get_contents($template)."</page>";
        $content = str_replace("##Reference##",$prises->getIdStagiaires()->getIdGroupes()->getCde(),$content);
        $content = str_replace("##Vos_Reference##",$nom_stagiaires,$content);         
        $content = str_replace("##Cout##",number_format($prises->getMontant(),2,',',' '),$content);
        $content = str_replace("##NOM_FORMATION##",$prises->getIdStagiaires()->getIdFormations()->getLib(),$content);
        $content = str_replace("##DATE_FORMATION##",$periode,$content);
        $content = str_replace("##Date_JOUR##",$datedujour,$content);
       // $content = str_replace("##Num_Cheque##",$prises->getNumcheque(),$content); 
        $content = str_replace("##COUT##",number_format($montant_relance,2,',',' '),$content); 
        if($option==0){
                    $content = str_replace("##Destinataire##",$prises->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Ordre##",$prises->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Complement##",$prises->getIdOrganismes()->getReference(),$content); 
                    $content = str_replace("##Nom_Rue##",$prises->getIdOrganismes()->getAdrrue(),$content);
                    $content = str_replace("##BP##",$prises->getIdOrganismes()->getAdrbp(),$content);
                    $content = str_replace("##CP##",$prises->getIdOrganismes()->getAdrcp(),$content);        
                    $content = str_replace("##Villes##",$prises->getIdOrganismes()->getAdrville(),$content);  
        }
        if($option==1){
                    $content = str_replace("##Destinataire##",$nom_stagiaires,$content);
                    $content = str_replace("##Ordre##",$nom_stagiaires,$content);
                    $content = str_replace("##Complement##",' ',$content);
                    $content = str_replace("##Nom_Rue##",$prises->getIdStagiaires()->getAdrrue(),$content);        
                    $content = str_replace("##BP##",' ',$content);
                    $content = str_replace("##CP##",$prises->getIdStagiaires()->getAdrcp(),$content);        
                    $content = str_replace("##Villes##",$prises->getIdStagiaires()->getAdrville(),$content);     
        }
        if($option==2){
                    $content = str_replace("##Destinataire##",$ligne1,$content); 
                    $content = str_replace("##Ordre##",$ligne1,$content);
                    $content = str_replace("##Complement##",$ligne2,$content);
                    $content = str_replace("##Nom_Rue##",$ligne3,$content);        
                    $content = str_replace("##BP##",$ligne5,$content);
                    $content = str_replace("##CP##",$ligne5,$content);        
                    $content = str_replace("##Ville##",$ligne6,$content);   
        }
        $content = str_replace("##Logo##",$image,$content);   


        $html2pdf->WriteHTML($content);
        $content_PDF = $html2pdf->Output('', true);  
        
        $response = new Response();

        // Set headers
        $response->headers->set('Cache-Control', 'private');
        $response->headers->set('Content-type', 'application/pdf');
        $response->headers->set('Content-Disposition', 'filename="relance.pdf"');

        // Send headers before outputting anything
        $response->sendHeaders();

        $response->setContent( $content_PDF);        
        return $response;
    } 
}
