<?php

namespace alldevs\IfocopBundle\Controller\Reglement;

use Admingenerated\alldevsIfocopBundle\BaseReglementController\EditController as BaseEditController;
use Exception;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

class EditController extends BaseEditController
{
    public function indexAction($pk)
    {
        $Reglement = $this->getObject($pk);

        if (!$Reglement) {
            throw new NotFoundHttpException("The alldevs\IfocopBundle\Entity\Reglement with id $pk can't be found");
        }

        $this->preForm($Reglement);

        $form = $this->createForm($this->getEditType(), $Reglement);

        return $this->render('alldevsIfocopBundle:ReglementEdit:index.html.twig', $this->getAdditionalRenderParameters($Reglement) + array(
            "Reglement" => $Reglement,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1),
            'mem' => ($this->get('request')->get('mem')!=null?$this->get('request')->get('mem'):-1)          
        ));
    }

    public function preSave(\Symfony\Component\Form\Form $form, \alldevs\IfocopBundle\Entity\Reglement $Reglement)
    {
        $session=$this->get('request')->getSession();
        
        $req=$this->get('request');
        //if ($req->getMethod()=="POST" && $req->request->has('save-and-add')){
            if($Reglement->getIdStagiaires()->getId()){
                if($session->get('usernow')!=$Reglement->getIdStagiaires()->getId()){
                    $session->set('usernow', $Reglement->getIdStagiaires()->getId());
                    $session->set('banquetireur', $Reglement->getBanquetireur());
                    $session->set('tireur', $Reglement->getTireur());
                    $session->set('renew', '1'); 
                }
            }else{
                if($session->get('usernow')!=$Reglement->getIdPrises()->getIdStagiaires()->getId()){
                    $session->set('usernow', $Reglement->getIdPrises()->getIdStagiaires()->getId());
                    $session->set('banquetireur', $Reglement->getBanquetireur());
                    $session->set('tireur', $Reglement->getTireur());
                    $session->set('renew', '1'); 
                }            
            }
        //}

    } 
    
    public function updateAction($pk)
    {
        $Reglement = $this->getObject($pk);

        if (!$Reglement) {
            throw new NotFoundHttpException("The alldevs\IfocopBundle\Entity\Reglement with id $pk can't be found");
        }

        $this->preBindRequest($Reglement);
        $form = $this->createForm($this->getEditType(), $Reglement);
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $Reglement);
                $this->saveObject($Reglement);
                $this->postSave($form, $Reglement);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                
                if($this->get('request')->request->has('imprimer')){
                    return $this->choixrmbReglement($Reglement);
                }
                
                if($this->get('request')->request->has('save-and-add'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_new" )."?mem=1&modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_new" )."?mem=1");
                }
                if($this->get('request')->request->has('save-and-list'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_list" )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_list" ));
                }
                else
                {
                     if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_edit", array('pk' => $pk) )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                     else
                         return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_edit", array('pk' => $pk) ));
                }
            } catch (\Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Reglement);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('alldevsIfocopBundle:ReglementEdit:index.html.twig', $this->getAdditionalRenderParameters($Reglement) + array(
            "Reglement" => $Reglement,
            "form" => $form->createView(),
            "modale"=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1)   ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1),
            'mem' => ($this->get('request')->get('mem')!=null?$this->get('request')->get('mem'):-1)
        ));
    }
    
    public function choixrmbReglement($Reglement){
        return $this->render('alldevsIfocopBundle:ReglementList:choixremb.html.twig', array(
            "Reglement" => $Reglement
        ));
    }
}
