<?php

namespace alldevs\IfocopBundle\Controller\Reglement;

use Admingenerated\alldevsIfocopBundle\BaseReglementController\ListController as BaseListController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;



class ListController extends BaseListController
{
    public function indexAction()
    {
        if ($this->get('request')->query->get('page'))
        {
          $this->setPage($this->get('request')->query->get('page'));
        }

        if ($this->get('request')->query->get('sort'))
        {
          $this->setSort($this->get('request')->query->get('sort'), $this->get('request')->query->get('order_by','ASC'));
        }

        $form = $this->getFilterForm();
        $cmd=$this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:Reglement');
        $names=$cmd->getAssociationNames();
        $assocs=array();
        foreach ($names as $name)
        {
            if (!$cmd->isCollectionValuedAssociation($name))
            {   
                $tab=explode('\\',$cmd->getAssociationTargetClass($name));
                $assname=$tab[count($tab)-1];
                $meta = $this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:'.$assname);
                $identifier = $meta->getSingleIdentifierFieldName();
                $assocs[$name]=array("field"=>$assname,"refid"=>$identifier);
            }
        }
        $multiids=array();
        if ($this->get('request')->query->has('isMulti') && $this->get('request')->query->get('motherid')!='')
        {
            $reprel = $this->getDoctrine()->getRepository('alldevsIfocopBundle:'.$this->get('request')->query->get('motherentity'));
            $relobj=$reprel->find($this->get('request')->query->get('motherid'));  

            $pos=strpos($this->get('request')->query->get('class'),":");
            $getter="getId".substr($this->get('request')->query->get('class'),$pos+1);
            foreach ($relobj->$getter() as $stg)
            {
                $multiids[]=$stg->getId();
            }
        }
        return $this->render('alldevsIfocopBundle:ReglementList:index.html.twig', $this->getAdditionalRenderParameters() + array(
            'Reglements' => $this->getPager(),
            'form'                      => $form->createView(),
            'sortColumn'                => $this->getSortColumn(),
            'sortOrder'                 => $this->getSortOrder(),
            'scopes'                    => $this->getScopes(),
            'assocs'                  => $assocs,
            'isSelect'   =>  $this->get('request')->query->has('isSelect'),
            'isMulti'   =>  $this->get('request')->query->has('isMulti'),
            'multiids' => $multiids,
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1) ,            
            'modale'=>($this->get('request')->get('modale')!=null?true:false)   
        ));
    }
    
    public function buildQuery() {
        $securityContext = $this->container->get('security.context');
        $myuser=$securityContext->getToken()->getUser();
        $q = parent::buildQuery();
        if ($securityContext->isGranted('ROLE_CENTRE')) {
            $q->innerJoin("q.idStagiaires", "s")->innerJoin("s.idGroupes", "g")->innerJoin("g.idCentres", "c")->andWhere("c.id=".$this->getRequest()->getSession()->get("centre")->getId()."");
        }
        return $q;
    }
    public  function doBatchValidate(array $ids)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $repo=$em->getRepository('alldevsIfocopBundle:Reglement');
        foreach ($ids as $id)
        {
            $reg=$repo->find($id);
            if ($reg)
            {
                $reg->setValidation(1);
                $em->persist($reg);
            }
        }
        $em->flush();
    }
    
    public function recuAction($pk)
    {
        $html2pdf = $this->get('html2pdf')->get();
        $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/recu.html";
        $image=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/images/logo_ifocop.png";
        
        $reglement=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Reglement')->find($pk); 
        
        
        $content = "<page>".file_get_contents($template)."</page>";
        $content = str_replace("##Nom##",$reglement->getIdStagiaires()->getNom(),$content);
        $content = str_replace("##Prenom##",$reglement->getIdStagiaires()->getPrenom(),$content);        
        $content = str_replace("##Formation##",$reglement->getIdStagiaires()->getIdGroupes()->getLib(),$content);        
        $content = str_replace("##Date début##",$reglement->getIdStagiaires()->getDatedebut()->format("d/m/Y"),$content);      
        $content = str_replace("##Date fin##",$reglement->getIdStagiaires()->getDatefin()->format("d/m/Y"),$content);   
        $content = str_replace("##Antenne##",$reglement->getIdStagiaires()->getIdGroupes()->getIdCentres()->getLib(),$content);          
        $content = str_replace("##Montant##",number_format($reglement->getMontant(),2),$content);          
        $content = str_replace("##Moyen##",$reglement->getIdModalite()->getLib(),$content);          
        $content = str_replace("##Datejour##",date("d/m/Y"),$content);   
        $content = str_replace("##Logo##",$image,$content);           
        if($reglement->getTypecompte()!=3){
            if($reglement->getTypecompte()==1){
                $content = str_replace("##Num_Compte##",'CS : '.$reglement->getNumcomptecs(),$content); 
            }else{
                $content = str_replace("##Num_Compte##",'DI : '.$reglement->getNumcomptedi(),$content); 
            }
        }else{
            $content = str_replace("##Num_Compte##",'CS : '.$reglement->getNumcomptecs().' et DI : '.$reglement->getNumcomptedi(),$content);
        }

        $html2pdf->WriteHTML($content);
        $content_PDF = $html2pdf->Output('', true);  
        
        $response = new Response();

        // Set headers
        $response->headers->set('Cache-Control', 'private');
        $response->headers->set('Content-type', 'application/pdf');
        $response->headers->set('Content-Disposition', 'filename="recu.pdf"');

        // Send headers before outputting anything
        $response->sendHeaders();

        $response->setContent( $content_PDF);        
        return $response;
    } 
    public function relanceAction($pk)
    {
        $reglement=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Reglement')->find($pk); 
        return $this->render('alldevsIfocopBundle:ReglementList:choixrelance.html.twig', array(
            "Reglement" => $reglement
        ));
    }
    
    public function relancerAction(Request $request)
    {
        $id=$request->get("pk");

        if($request->get('option')==0){
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'));
        }
        if($request->get('option')==1){
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'));
        }
        if($request->get('option')==2){
            $ligne1=$request->get('destinataire');
            $ligne2=$request->get('adrcomplement');
            $ligne3=$request->get('adrrue');
            $ligne4=$request->get('adrcp');
            $ligne5=$request->get('adrville');
            $ligne6=$request->get('adrbp');
            
            return $this->generateRelance($id,$request->get('option'),$request->get('montantrelance'),$request->get('typerelance'),$ligne1,$ligne2,$ligne3,$ligne4,$ligne5,$ligne6);
        }
    }
    
    public function generateRelance($pk,$option,$montant_relance,$type_relance,$ligne1=NULL,$ligne2=NULL,$ligne3=NULL,$ligne4=NULL,$ligne5=NULL,$ligne6=NULL)
    {
        $html2pdf = $this->get('html2pdf')->get();
        if($type_relance==1){
            $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/relance1.html";
        }else{
            $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/relance2.html";
        }
        $image=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/images/logo_ifocop.png";

        $reglement=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Reglement')->find($pk); 
        $nom_stagiaires=$reglement->getIdStagiaires()->getNom()." ".$reglement->getIdStagiaires()->getPrenom();
        $periode="du ".$reglement->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y")." au ".$reglement->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y");
        setlocale (LC_TIME, 'fr_FR.utf8','fra');
        $datedujour=(strftime("%d %B %Y"));

        $content = "<page backtop=\"0mm\" backbottom=\"-15mm\" backleft=\"0mm\" backright=\"0mm\">".file_get_contents($template)."</page>";
        $content = str_replace("##Reference##",$reglement->getIdStagiaires()->getIdGroupes()->getCde(),$content);
        $content = str_replace("##Vos_Reference##",$nom_stagiaires,$content);         
        $content = str_replace("##Cout##",number_format($reglement->getMontant(),2,',',' '),$content);
        $content = str_replace("##NOM_FORMATION##",$reglement->getIdStagiaires()->getIdFormations()->getLib(),$content);
        $content = str_replace("##DATE_FORMATION##",$periode,$content);
        $content = str_replace("##Date_JOUR##",$datedujour,$content);
        $content = str_replace("##Num_Cheque##",$reglement->getNumcheque(),$content); 
        $content = str_replace("##COUT##",number_format($montant_relance,2,',',' '),$content); 
        if($option==0){
                    $content = str_replace("##Destinataire##",$reglement->getIdPrises()->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Ordre##",$reglement->getIdPrises()->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Complement##",$reglement->getIdPrises()->getIdOrganismes()->getComplement(),$content); 
                    $content = str_replace("##Nom_Rue##",$reglement->getIdPrises()->getIdOrganismes()->getAdrrue(),$content);
                    $content = str_replace("##BP##",$reglement->getIdPrises()->getIdOrganismes()->getBp(),$content);
                    $content = str_replace("##CP##",$reglement->getIdPrises()->getIdOrganismes()->getAdrcp(),$content);        
                    $content = str_replace("##Ville##",$reglement->getIdPrises()->getIdOrganismes()->getAdrville(),$content);  
        }
        if($option==1){
                    $content = str_replace("##Destinataire##",$nom_stagiaires,$content);
                    $content = str_replace("##Ordre##",$nom_stagiaires,$content);
                    $content = str_replace("##Complement##",' ',$content);
                    $content = str_replace("##Nom_Rue##",$reglement->getIdStagiaires()->getAdrrue(),$content);        
                    $content = str_replace("##BP##",' ',$content);
                    $content = str_replace("##CP##",$reglement->getIdStagiaires()->getAdrcp(),$content);        
                    $content = str_replace("##Villes##",$reglement->getIdStagiaires()->getAdrville(),$content);     
        }
        if($option==2){
                    $content = str_replace("##Destinataire##",$ligne1,$content); 
                    $content = str_replace("##Ordre##",$ligne1,$content);
                    $content = str_replace("##Complement##",$ligne2,$content);
                    $content = str_replace("##Nom_Rue##",$ligne3,$content);        
                    $content = str_replace("##BP##",$ligne5,$content);
                    $content = str_replace("##CP##",$ligne5,$content);        
                    $content = str_replace("##Ville##",$ligne6,$content);   
        }
        $content = str_replace("##Logo##",$image,$content);   


        $html2pdf->WriteHTML($content);
        $content_PDF = $html2pdf->Output('', true);  
        
        $response = new Response();

        // Set headers
        $response->headers->set('Cache-Control', 'private');
        $response->headers->set('Content-type', 'application/pdf');
        $response->headers->set('Content-Disposition', 'filename="relance.pdf"');

        // Send headers before outputting anything
        $response->sendHeaders();

        $response->setContent( $content_PDF);        
        return $response;
    } 
    
    public function rmbAction($pk)
    {
        $reglement=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Reglement')->find($pk); 
        return $this->render('alldevsIfocopBundle:ReglementList:choixremb.html.twig', array(
            "Reglement" => $reglement
        ));
    }
    
    public function imprimerAction(Request $request)
    {
        $id=$request->get("pk");
        if($request->get('option')==0){
            return $this->generateReglement($id,$request->get('option'));
        }
        if($request->get('option')==1){
            return $this->generateReglement($id,$request->get('option'));
        }
        if($request->get('option')==2){
            $ligne1=$request->get('destinataire');
            $ligne2=$request->get('adrcomplement');
            $ligne3=$request->get('adrrue');
            $ligne4=$request->get('adrcp');
            $ligne5=$request->get('adrville');
            $ligne6=$request->get('adrbp');
            
            return $this->generateReglement($id,$request->get('option'),$ligne1,$ligne2,$ligne3,$ligne4,$ligne5,$ligne6);
        }
    }
    
    public function generateReglement($pk,$option,$ligne1=NULL,$ligne2=NULL,$ligne3=NULL,$ligne4=NULL,$ligne5=NULL,$ligne6=NULL)
    {
        
        function int2str($a)
        {
            $convert = explode('.',$a);
            if (isset($convert[1]) && $convert[1]!=''){
                if($convert[1]!='00'){
                    return int2str($convert[0]).' EURO'.' et '.int2str($convert[1]).' CENT' ;
                }else{
                    return int2str($convert[0]).' EURO';
                }
            }
            
            if ($a<0) return 'moins '.int2str(-$a);
            if ($a<17){
                switch ($a){
                case 0: return 'zero';
                case 1: return 'un';
                case 2: return 'deux';
                case 3: return 'trois';
                case 4: return 'quatre';
                case 5: return 'cinq';
                case 6: return 'six';
                case 7: return 'sept';
                case 8: return 'huit';
                case 9: return 'neuf';
                case 10: return 'dix';
                case 11: return 'onze';
                case 12: return 'douze';
                case 13: return 'treize';
                case 14: return 'quatorze';
                case 15: return 'quinze';
                case 16: return 'seize';
                }
            } else if ($a<20){
                return 'dix-'.int2str($a-10);
            } else if ($a<100){
                if ($a%10==0){
                switch ($a){
                case 20: return 'vingt';
                case 30: return 'trente';
                case 40: return 'quarante';
                case 50: return 'cinquante';
                case 60: return 'soixante';
                case 70: return 'soixante-dix';
                case 80: return 'quatre-vingt';
                case 90: return 'quatre-vingt-dix';
            }
            } elseif (substr($a, -1)==1){
            if( ((int)($a/10)*10)<70 ){
                return int2str((int)($a/10)*10).'-et-un';
            } elseif ($a==71) {
                return 'soixante-et-onze';
            } elseif ($a==81) {
                return 'quatre-vingt-un';
            } elseif ($a==91) {
                return 'quatre-vingt-onze';
            }
            } elseif ($a<70){
                return int2str($a-$a%10).'-'.int2str($a%10);
            } elseif ($a<80){
                return int2str(60).'-'.int2str($a%20);
            } else{
                return int2str(80).'-'.int2str($a%20);
            }
            } else if ($a==100){
                return 'cent';
            } else if ($a<200){
                return int2str(100).' '.int2str($a%100);
            } else if ($a<1000){
                return int2str((int)($a/100)).' '.int2str(100).' '.int2str($a%100);
            } else if ($a==1000){
                return 'mille';
            } else if ($a<2000){
                return int2str(1000).' '.int2str($a%1000).' ';
            } else if ($a<1000000){
                return int2str((int)($a/1000)).' '.int2str(1000).' '.int2str($a%1000);
            }
            else if ($a==1000000){
                return 'millions';
            }
            else if ($a<2000000){
                return int2str(1000000).' '.int2str($a%1000000).' ';
            }
            else if ($a<1000000000){
                return int2str((int)($a/1000000)).' '.int2str(1000000).' '.int2str($a%1000000);
            }
        }

        $html2pdf = $this->get('html2pdf')->get();
        $template=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/templates/cheque.html";
        $image=$this->get('kernel')->getRootDir()."/../web/bundles/ifocop/images/logo_ifocop.png";

        $reglement=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Reglement')->find($pk); 
        
        $nom_stagiaires=$reglement->getIdStagiaires()->getNom()." ".$reglement->getIdStagiaires()->getPrenom();
        $periode="du ".$reglement->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y")." au ".$reglement->getIdStagiaires()->getIdGroupes()->getDatefin()->format("d/m/Y");
        setlocale (LC_TIME, 'fr_FR.utf8','fra');
        
        $datedujour=(strftime("%d %B %Y", strtotime($reglement->getDatereception()->format("m/d/Y"))));
        $datecheque=$reglement->getDatereception()->format("d/m/Y");


        $content = "<page backtop=\"0mm\" backbottom=\"-15mm\" backleft=\"0mm\" backright=\"0mm\">".file_get_contents($template)."</page>";                              
        $content = str_replace("##Cout##",number_format($reglement->getMontant(),2,',',' '),$content);
        if($reglement->getRmbcs()!=NULL){
            $ligne_table_cs='<tr><td style="padding-left:4px;">'.$datecheque.'</td><td>CS - Contribution Stagiaire</td><td style="text-align:right;">'.number_format($reglement->getRmbcs(),2,',',' ').' €</td></tr>';
        }else{
            $ligne_table_cs=" ";
        }
        $content = str_replace("##CS##",$ligne_table_cs,$content);
        if($reglement->getRmbdi()!=NULL){
            $ligne_table_di='<tr><td style="padding-left:4px;">'.$datecheque.'</td><td>DI - Droit d\'inscription</td><td style="text-align:right;">'.number_format($reglement->getRmbdi(),2,',',' ').' €</td></tr>';
        }else{
            $ligne_table_di=" ";
        }
        $montant_lettre=int2str(number_format($reglement->getMontant(),2,'.',' '));
        $content = str_replace("##DI##",$ligne_table_di,$content);
        $content = str_replace("##Date_JOUR##",$datedujour,$content);
        $content = str_replace("##Num_Cheque##",$reglement->getNumcheque(),$content); 
        $content = str_replace("##Montant##",number_format($reglement->getMontant(),2,',',' '),$content); 
        if($option==0){
                    $content = str_replace("##Destinataire##",$reglement->getIdPrises()->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Ordre##",$reglement->getIdPrises()->getIdOrganismes()->getLib(),$content);
                    $content = str_replace("##Complement##",$reglement->getIdPrises()->getIdOrganismes()->getComplement(),$content); 
                    $content = str_replace("##Nom_Rue##",$reglement->getIdPrises()->getIdOrganismes()->getAdrrue(),$content);
                    $content = str_replace("##BP##",$reglement->getIdPrises()->getIdOrganismes()->getBp(),$content);
                    $content = str_replace("##CP##",$reglement->getIdPrises()->getIdOrganismes()->getAdrcp(),$content);        
                    $content = str_replace("##Ville##",$reglement->getIdPrises()->getIdOrganismes()->getAdrville(),$content);  
        }
        if($option==1){
                    $content = str_replace("##Destinataire##",$nom_stagiaires,$content);
                    $content = str_replace("##Ordre##",$nom_stagiaires,$content);
                    $content = str_replace("##Complement##",' ',$content);
                    $content = str_replace("##Nom_Rue##",$reglement->getIdStagiaires()->getAdrrue(),$content);        
                    $content = str_replace("##BP##",' ',$content);
                    $content = str_replace("##CP##",$reglement->getIdStagiaires()->getAdrcp(),$content);        
                    $content = str_replace("##Ville##",$reglement->getIdStagiaires()->getAdrville(),$content);     
        }
        if($option==2){
                    $content = str_replace("##Destinataire##",$ligne1,$content); 
                    $content = str_replace("##Ordre##",$ligne1,$content);
                    $content = str_replace("##Complement##",$ligne2,$content);
                    $content = str_replace("##Nom_Rue##",$ligne3,$content);        
                    $content = str_replace("##BP##",$ligne5,$content);
                    $content = str_replace("##CP##",$ligne5,$content);        
                    $content = str_replace("##Ville##",$ligne6,$content);   
        }
        $content = str_replace("##Logo##",$image,$content);   
        $content = str_replace("##Date##",$datecheque,$content); 
        $content = str_replace("##Ordre##",$image,$content); 
        $content = str_replace("##Montant_lettre##",$montant_lettre,$content); 


        $html2pdf->WriteHTML($content);
        $content_PDF = $html2pdf->Output('', true);  
        
        $response = new Response();

        // Set headers
        $response->headers->set('Cache-Control', 'private');
        $response->headers->set('Content-type', 'application/pdf');
        $response->headers->set('Content-Disposition', 'filename="cheque.pdf"');

        // Send headers before outputting anything
        $response->sendHeaders();

        $response->setContent( $content_PDF);        
        return $response;
    } 

}
