<?php

namespace alldevs\IfocopBundle\Controller\Stagiairessimple;

use Admingenerated\alldevsIfocopBundle\BaseStagiairessimpleController\EditController as BaseEditController;
use alldevs\IfocopBundle\Entity\Stagiaires;
use Exception;
use Symfony\Component\Form\Form;
use Symfony\Component\Form\FormError;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\Validator\Constraints\NotNull;

class EditController extends BaseEditController
{
        /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \alldevs\IfocopBundle\Entity\Stagiaires $Stagiaires your \alldevs\IfocopBundle\Entity\Stagiaires object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \alldevs\IfocopBundle\Entity\Stagiaires $Stagiaires)
    {
        if ($Stagiaires->getIdPrises())
        {
            foreach ($Stagiaires->getIdPrises() as $line)
            {
                $line->setIdStagiaires($Stagiaires);
            }
        }
    }
    
    public function updateAction($pk)
    {
        $Stagiaires = $this->getObject($pk);
        if (!$Stagiaires) {
            throw new NotFoundHttpException("The alldevs\IfocopBundle\Entity\Stagiaires with id $pk can't be found");
        }

        $this->preBindRequest($Stagiaires);
        $form = $this->createForm($this->getEditType(), $Stagiaires);
        $form->bind($this->get('request'));
        
        $errorList = $this->get('validator')->validateValue($form["idGroupes"]->getData(), new NotNull());
        
        if ($form->isValid() && count($errorList)==0) {
            try {
                $this->preSave($form, $Stagiaires);
                $this->saveObject($Stagiaires);
                $this->postSave($form, $Stagiaires);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );

                if($this->get('request')->request->has('save-and-add'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Stagiairessimple_new" ));
                if($this->get('request')->request->has('save-and-list'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Stagiairessimple_list" ));
                else
                  return $this->getReturnFunction($pk);
            } catch (\Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Stagiaires);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
            if(count($errorList)>0){
                $error = new FormError("Ce champs est requis");
                $form->get('idGroupes')->addError($error);
            }
        }

        return $this->render('alldevsIfocopBundle:StagiairessimpleEdit:index.html.twig', $this->getAdditionalRenderParameters($Stagiaires) + array(
            "Stagiaires" => $Stagiaires,
            "form" => $form->createView(),
        ));
    }

}
