<?php

namespace alldevs\IfocopBundle\Controller\Stagiairessimple;

use Admingenerated\alldevsIfocopBundle\BaseStagiairessimpleController\NewController as BaseNewController;
use alldevs\IfocopBundle\Entity\Stagiaires;
use Exception;
use Symfony\Component\Form\Form;
use Symfony\Component\Form\FormError;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\Validator\Constraints\NotNull;

class NewController extends BaseNewController
{
        /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param Stagiaires $Stagiaires your \alldevs\IfocopBundle\Entity\Stagiaires object
     */
    public function preSave(Form $form, Stagiaires $Stagiaires)
    {
        if ($Stagiaires->getIdPrises())
        {
            foreach ($Stagiaires->getIdPrises() as $line)
            {
                $line->setIdStagiaires($Stagiaires);
            }
        }
        
        $Stagiaires->setCs($Stagiaires->getIdFormations()->getTarif());
        $Stagiaires->setDi($Stagiaires->getIdFormations()->getDroitinscr());
        $Stagiaires->setTypeannee($Stagiaires->getIdGroupes()->getTypeannee());
        $Stagiaires->setDatedebut($Stagiaires->getIdGroupes()->getDatedebut());
        $Stagiaires->setDatefin($Stagiaires->getIdGroupes()->getDatefin());
        $Stagiaires->setDateannee($Stagiaires->getIdGroupes()->getDateannee());

        $di=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Di')->findAll();  
        foreach ($di as $droit)
        {
            $Stagiaires->setComptedi($droit->getComptedi());        
            $Stagiaires->setComptecs($droit->getComptecs());                    
        }
    }
    
    public function createAction()
    {
        $Stagiaires = $this->getNewObject();

        $this->preBindRequest($Stagiaires);
        $form = $this->createForm($this->getNewType(), $Stagiaires);
        $form->bind($this->get('request'));
        
        $errorList = $this->get('validator')->validateValue($form["idGroupes"]->getData(), new NotNull());
        
        if ($form->isValid() && count($errorList)==0) {
            try {
                $this->preSave($form, $Stagiaires);
                $this->saveObject($Stagiaires);
                $this->postSave($form, $Stagiaires);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );

                if($this->get('request')->request->has('save-and-add'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Stagiaires_new" ));
                if($this->get('request')->request->has('save-and-list'))
                  return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Stagiaires_list" ));
                else
                  return $this->getReturnFunction($Stagiaires);
            } catch (Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Stagiaires);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
            if(count($errorList)>0){
                $error = new FormError("Ce champs est requis");
                $form->get('idGroupes')->addError($error);
            }
        }

        return $this->render('alldevsIfocopBundle:StagiairessimpleNew:index.html.twig', $this->getAdditionalRenderParameters($Stagiaires) + array(
            "Stagiaires" => $Stagiaires,
            "form" => $form->createView(),
        ));
    }

}
