<?php

namespace alldevs\IfocopBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use  alldevs\IfocopBundle\Form\Type\Synthese\SyntheseSearchType;

class SyntheseController extends Controller
{
    public function indexAction(Request $request)
    {
        $session=$this->getRequest()->getSession();
        $securityContext=$this->container->get('security.context') ;
        $user=$securityContext->getToken()->getUser(); 
        session_cache_limiter('public');
        
        $data=array();
        if($securityContext->isGranted("ROLE_CENTRE")){   
            $centres=$this->getRequest()->getSession()->get("centre")->getId();;    
        }else{
            $centres="";
        }
        $groupes="";
        $stage_solde = array();
        $groupe_solde = array();
        $centre_solde = array();
        if ($request->getMethod()=="POST" || $request->getMethod()=="GET")
        {
            $formdata=$request->get("synthese_search");
        
            if (isset($formdata["centres"]))
                $centres=$formdata["centres"];

            if (isset($formdata["annee"]))
                $annee=$formdata["annee"];
            else
                $annee="";            
            $groupes=$formdata["groupes"];        

            if(isset($formdata["datedebut"])){
                if($formdata["datedebut"]==''){
                    $datedebut= '1970-01-01 00:00:00';
                }else{
                    $exp=  explode('/', $formdata["datedebut"]);
                    $datedebut=$exp[2]."-".$exp[1]."-".$exp[0];
                }
            }
            if(isset($formdata["datefin"])){
                if($formdata["datefin"]==''){
                    $datefin= '2225-12-31 00:00:00';
                }else{
                    $exp=  explode('/', $formdata["datefin"]);
                    $datefin=$exp[2]."-".$exp[1]."-".$exp[0];
                }
            }
        }
        
        $form = $this->createForm(new SyntheseSearchType($groupes, $centres, $securityContext), $data);        
        $q=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Centres')->createQueryBuilder("c"); 
        $q->innerJoin("c.idGroupes","g")->innerJoin("g.idStagiaires","s")->leftJoin("s.idReglement","r")->innerJoin("s.idFormations","f")->orderBy("c.lib","asc")->orderBy("g.lib","asc")->orderBy("f.lib","asc")->orderBy("s.nom","asc");
        if ($securityContext->isGranted('ROLE_CENTRE'))  
        {
           $q->andWhere("c.id=:idc")->setParameter('idc', $this->getRequest()->getSession()->get("centre")->getId());           
        }
        
        if ($request->getMethod()=="POST" || $request->getMethod()=="GET")
        {
             $form->bind($request);
             $q->select("c,g,s,r"); 
             
                if ( $groupes!="")
                   $q->andWhere("g.id=".$groupes);        
                if ( $formdata["stagiaires"]!="")
                    $q->andWhere("s.id=".$formdata["stagiaires"]);                   
                
             if ($securityContext->isGranted('ROLE_CENTRE'))  
             {
                 $q->andWhere("c.id=:idc")->setParameter('idc', $this->getRequest()->getSession()->get("centre")->getId());                 
                if ($annee!="")
                    $q->andWhere("g.dateannee='".$annee."'");
             }
             else
             {
                if ( $centres!="")                 
                    $q->andWhere("c.id=".$centres);                
          
                if ( isset($formdata["valid"]))
                    $q->andWhere("r.validation=1");             
                if ( $formdata["datedebut"]!="")
                    $q->andWhere("(g.datedebut >= :debut and g.datedebut<= :fin) or (g.datefin >= :debut and g.datefin<= :fin)")->setParameter("debut", $datedebut)->setParameter("fin", $datefin);                          
             }
        }
        
        $securityContext = $this->container->get('security.context');
        $user= $securityContext->getToken()->getUser();                        
        

            $Centreslist=$q->getQuery()->execute();

            /*
             * Mise en mémoire des soldes negatif
             */

             if (isset($formdata["negatif"])){
                if($Centreslist!=""){
                       
                       foreach ($Centreslist as $c)
                       {
                           $centre_solde[$c->getId()]=1;
                           foreach ($c->getIdGroupes() as $g)
                           {
                               $groupe_solde[$g->getId()]=1;
                               foreach ($g->getIdStagiaires() as $s)
                               {
                                   $total_stag_cs=$s->getCs();
                                   $total_stag_csp=0;
                                   $total_stag_cse=0;
                                   $total_stag_di=$s->getDi();
                                   $total_stag_dip=0;
                                   $total_stag_die=0; 
                                   $total_stag_solde=0;
  
                                   foreach ($s->getIdReglement() as $r)
                                   {                                      
                                       $total_stag_cse+=($r->getTypecompte()==1 && $r->getValidation()==1?(($r->getIdModalite()->getLib()=="Remboursement") || ($r->getIdModalite()->getLib()=="Régularisation négative") || ($r->getIdModalite()->getLib()=="Chèque impayé"))?-1*$r->getMontant():$r->getMontant():0);
                                       $total_stag_die+=($r->getTypecompte()==2 && $r->getValidation()==1?(($r->getIdModalite()->getLib()=="Remboursement") || ($r->getIdModalite()->getLib()=="Régularisation négative") || ($r->getIdModalite()->getLib()=="Chèque impayé"))?-1*$r->getMontant():$r->getMontant():0);
                                   }
                                   $stage_solde[$s->getId()]=($total_stag_cs+$total_stag_di)-($total_stag_cse+$total_stag_die);
                                   if(($total_stag_cs+$total_stag_di)-($total_stag_cse+$total_stag_die) < 0){
                                       $groupe_solde[$g->getId()]=0;
                                       $centre_solde[$c->getId()]=0;
                                   }
                               }   
                           }
                     }
                }
     
           }else{
               unset($stage_solde);
               $stage_solde = array();
               unset($groupe_solde);
               $groupe_solde = array();
               unset($centre_solde);
               $centre_solde = array();
           }
           
           
        $excelService = $this->get('xls.service_xls2007');

        $excelService->excelObj->getProperties()->setCreator("Ifocop")
                            ->setTitle("Synthèse excel");
        $sheet=$excelService->excelObj->setActiveSheetIndex(0);
                
        $row=1;
        
        $sheet->setCellValueByColumnAndRow(0,$row,"Type total");
        $sheet->setCellValueByColumnAndRow(1,$row,"Centre");
        $sheet->setCellValueByColumnAndRow(2,$row,"Groupe");
        $sheet->setCellValueByColumnAndRow(3,$row,"Formation");
        $sheet->setCellValueByColumnAndRow(4,$row,"Total CS dû");
        $sheet->setCellValueByColumnAndRow(5,$row,"CS prévu");
        $sheet->setCellValueByColumnAndRow(6,$row,"Mis en banque");        
        $sheet->setCellValueByColumnAndRow(7,$row,"Total DI dû");        
        $sheet->setCellValueByColumnAndRow(8,$row,"DI prévu");
        $sheet->setCellValueByColumnAndRow(9,$row,"DI encaissé");                
        $sheet->setCellValueByColumnAndRow(10,$row,"Total dû");                    
        $row++;
       if($Centreslist!=""){
        foreach ($Centreslist as $c)
        {
            $total_centre_cs=0;
            $total_centre_csp=0;
            $total_centre_cse=0;
            $total_centre_di=0;
            $total_centre_dip=0;
            $total_centre_die=0;
            
            foreach ($c->getIdGroupes() as $g)
            {
                $total_groupe_cs=0;
                $total_groupe_csp=0;
                $total_groupe_cse=0;
                $total_groupe_di=0;
                $total_groupe_dip=0;
                $total_groupe_die=0;                
                
                $formlib="";
                $first=true;
                $total_form_cs=0;
                $total_form_csp=0;
                $total_form_cse=0;
                $total_form_di=0;
                $total_form_dip=0;
                $total_form_die=0; 

                foreach ($g->getIdStagiaires() as $s)
                {
                
                    if ($first)
                    {
                        $first=false;
                        $formlib=$s->getIdFormations()->getLib();
                    }
                    $total_stag_cs=$s->getCs();
                    $total_stag_csp=0;
                    $total_stag_cse=0;
                    $total_stag_di=$s->getDi();
                    $total_stag_dip=0;
                    $total_stag_die=0; 
                    
                    foreach ($s->getIdReglement() as $r)
                    {
                        $total_stag_csp+=($r->getTypecompte()==1?$r->getMontant():0);
                        $total_stag_cse+=($r->getTypecompte()==1 && $r->getValidation()==1?$r->getMontant():0) ;
                        $total_stag_dip+=($r->getTypecompte()==2?$r->getMontant():0);
                        $total_stag_die+=($r->getTypecompte()==2 && $r->getValidation()==1?$r->getMontant():0);                     
                    }
                    
                    if ($s->getIdFormations()->getLib()!=$formlib)
                    {
                        $sheet->setCellValueByColumnAndRow(0,$row,"Formation");
                        $sheet->setCellValueByColumnAndRow(1,$row,$c->getLib());
                        $sheet->setCellValueByColumnAndRow(2,$row,$g->getLib());
                        $sheet->setCellValueByColumnAndRow(3,$row,$formlib);
                        $sheet->setCellValueByColumnAndRow(4,$row,$total_form_cs);
                        $sheet->setCellValueByColumnAndRow(5,$row,$total_form_csp);
                        $sheet->setCellValueByColumnAndRow(6,$row,$total_form_cse);        
                        $sheet->setCellValueByColumnAndRow(7,$row,$total_form_di);        
                        $sheet->setCellValueByColumnAndRow(8,$row,$total_form_dip);
                        $sheet->setCellValueByColumnAndRow(9,$row,$total_form_die);                
                        $sheet->setCellValueByColumnAndRow(10,$row,$total_form_cs-$total_form_cse);                    
                        $row++;                           
                        
                        $formlib=$s->getIdFormations()->getLib();
                        $total_form_cs=0;
                        $total_form_csp=0;
                        $total_form_cse=0;
                        $total_form_di=0;
                        $total_form_dip=0;
                        $total_form_die=0; 
                    }                      
                    
                    $total_form_cs+=$total_stag_cs;
                    $total_form_csp+=$total_stag_csp;
                    $total_form_cse+=$total_stag_cse;
                    $total_form_di+=$total_stag_di;
                    $total_form_dip+=$total_stag_dip;
                    $total_form_die+=$total_stag_die; 
                    
                    $total_groupe_cs+=$total_stag_cs;
                    $total_groupe_csp+=$total_stag_csp;
                    $total_groupe_cse+=$total_stag_cse;
                    $total_groupe_di+=$total_stag_di;
                    $total_groupe_dip+=$total_stag_dip;
                    $total_groupe_die+=$total_stag_die;                     
                }
                
                $sheet->setCellValueByColumnAndRow(0,$row,"Formation");
                $sheet->setCellValueByColumnAndRow(1,$row,$c->getLib());
                $sheet->setCellValueByColumnAndRow(2,$row,$g->getLib());
                $sheet->setCellValueByColumnAndRow(3,$row,$formlib);
                $sheet->setCellValueByColumnAndRow(4,$row,$total_form_cs);
                $sheet->setCellValueByColumnAndRow(5,$row,$total_form_csp);
                $sheet->setCellValueByColumnAndRow(6,$row,$total_form_cse);        
                $sheet->setCellValueByColumnAndRow(7,$row,$total_form_di);        
                $sheet->setCellValueByColumnAndRow(8,$row,$total_form_dip);
                $sheet->setCellValueByColumnAndRow(9,$row,$total_form_die);                
                $sheet->setCellValueByColumnAndRow(10,$row,$total_form_cs-$total_form_cse);                    
                $row++;    
                
                
                $sheet->setCellValueByColumnAndRow(0,$row,"Groupe");
                $sheet->setCellValueByColumnAndRow(1,$row,$c->getLib());
                $sheet->setCellValueByColumnAndRow(2,$row,$g->getLib());
                $sheet->setCellValueByColumnAndRow(3,$row,"");
                $sheet->setCellValueByColumnAndRow(4,$row,$total_groupe_cs);
                $sheet->setCellValueByColumnAndRow(5,$row,$total_groupe_csp);
                $sheet->setCellValueByColumnAndRow(6,$row,$total_groupe_cse);        
                $sheet->setCellValueByColumnAndRow(7,$row,$total_groupe_di);        
                $sheet->setCellValueByColumnAndRow(8,$row,$total_groupe_dip);
                $sheet->setCellValueByColumnAndRow(9,$row,$total_groupe_die);                
                $sheet->setCellValueByColumnAndRow(10,$row,$total_groupe_cs-$total_groupe_cse);                    
                $row++;   
                
                    $total_centre_cs+=$total_groupe_cs;
                    $total_centre_csp+=$total_groupe_csp;
                    $total_centre_cse+=$total_groupe_cse;
                    $total_centre_di+=$total_groupe_di;
                    $total_centre_dip+=$total_groupe_dip;
                    $total_centre_die+=$total_groupe_die;                  
            }
            
            
            
                $sheet->setCellValueByColumnAndRow(0,$row,"Centre");
                $sheet->setCellValueByColumnAndRow(1,$row,$c->getLib());
                $sheet->setCellValueByColumnAndRow(2,$row,"");
                $sheet->setCellValueByColumnAndRow(3,$row,"");
                $sheet->setCellValueByColumnAndRow(4,$row,$total_centre_cs);
                $sheet->setCellValueByColumnAndRow(5,$row,$total_centre_csp);
                $sheet->setCellValueByColumnAndRow(6,$row,$total_centre_cse);        
                $sheet->setCellValueByColumnAndRow(7,$row,$total_centre_di);        
                $sheet->setCellValueByColumnAndRow(8,$row,$total_centre_dip);
                $sheet->setCellValueByColumnAndRow(9,$row,$total_centre_die);                
                $sheet->setCellValueByColumnAndRow(10,$row,$total_centre_cs-$total_centre_cse);                    
                $row++;             
            
        }
       }
        $excelService->excelObj->getActiveSheet()->setTitle("Synthèse excel");
        $filename="Synthese_".date("Ymd")."_".time().".xlsx";
        $excelService->getStreamWriter()->write( $this->container->get('kernel')->getRootDir()."/../web/synthese/".$filename);
        
        return $this->render('alldevsIfocopBundle:Synthese:index.html.twig', array("centres"=>$Centreslist,"solde"=>$stage_solde,"grsolde"=>$groupe_solde,"ctrsolde"=>$centre_solde,"filename"=>"/synthese/".$filename, "formulaire"=>$form->createView()));
    }

}
