<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Reglement
 *  
 * @ORM\Table(name="banquescentre")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\BanquescentreRepository")
 */
class Banquescentre
{
    
    /**
     *     
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;
    
    /**
     * 
     * @ORM\Column(name="banque", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $banque;
    
    /**
     * 
     * @ORM\Column(name="dombanque", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $dombanque;
    
    /**
     * 
     * @ORM\Column(name="cdebanque", type="string", length=255, nullable=true)
     * @Assert\MaxLength(5)  
     * @Assert\NotBlank()
     */
    private $cdebanque;

    /**
     * 
     * @ORM\Column(name="cdageance", type="string", length=255, nullable=true)
     * @Assert\MaxLength(5) 
     * @Assert\NotBlank()
     */
    private $cdeagence; 

    /**
     * 
     * @ORM\Column(name="numcompte", type="string", length=255, nullable=true)
     * @Assert\MaxLength(11) 
     * @Assert\NotBlank()
     */
    private $numcompte; 
    
    /**
     * 
     * @ORM\Column(name="clerib", type="string", length=255, nullable=true)
     * @Assert\MaxLength(2) 
     * @Assert\NotBlank()
     */
    private $clerib; 
    
    /**
     * 
     * @ORM\Column(name="iban", type="string", length=255, nullable=true)
     * @Assert\MaxLength(33) 
     * @Assert\NotBlank()
     */
    private $iban; 
    
    /**
     * 
     * @ORM\Column(name="banquefacture", type="boolean", nullable=true)
     */
    private $banquefacture;
    
    /**
     *   
     * @ORM\Column(name="adrrue", type="string", length=255, nullable=true)

     */
    private $adrrue;

    /**
     *   
     * @ORM\Column(name="adrville", type="string", length=255, nullable=true)
     * 
     */
    private $adrville;
    
    /**
     *      
     * @ORM\Column(name="adrcp", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(5)
     */
    private $adrcp;

    /**
     * @ORM\Column(name="telephone", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $telephone;
 
    /**
     * @ORM\Column(name="fax", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $fax;

    /**
     * @ORM\Column(name="email", type="string", length=100, nullable=true)
     * @Assert\MaxLength(70) 
     * @Assert\Email(
     *     message = "'{{ value }}' n'est pas un email valide."
     * ) 
     */
    private $email;
    
    /**
     * 
     * @ORM\ManyToOne(targetEntity="Centres")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_centres", referencedColumnName="id")
     * })
     * 
     */
    private $idCentres;
    
    public function __toString()
    {
            return $this->getBanque();
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set banque
     *
     * @param string $banque
     * @return Banquescentre
     */
    public function setBanque($banque)
    {
        $this->banque = $banque;
    
        return $this;
    }

    /**
     * Get banque
     *
     * @return string 
     */
    public function getBanque()
    {
        return $this->banque;
    }

    /**
     * Set cdebanque
     *
     * @param string $cdebanque
     * @return Banquescentre
     */
    public function setCdebanque($cdebanque)
    {
        $this->cdebanque = $cdebanque;
    
        return $this;
    }

    /**
     * Get cdebanque
     *
     * @return string 
     */
    public function getCdebanque()
    {
        return $this->cdebanque;
    }

    /**
     * Set cdeagence
     *
     * @param string $cdeagence
     * @return Banquescentre
     */
    public function setCdeagence($cdeagence)
    {
        $this->cdeagence = $cdeagence;
    
        return $this;
    }

    /**
     * Get cdeagence
     *
     * @return string 
     */
    public function getCdeagence()
    {
        return $this->cdeagence;
    }

    /**
     * Set adrrue
     *
     * @param string $adrrue
     * @return Banquescentre
     */
    public function setAdrrue($adrrue)
    {
        $this->adrrue = $adrrue;
    
        return $this;
    }

    /**
     * Get adrrue
     *
     * @return string 
     */
    public function getAdrrue()
    {
        return $this->adrrue;
    }

    /**
     * Set adrville
     *
     * @param string $adrville
     * @return Banquescentre
     */
    public function setAdrville($adrville)
    {
        $this->adrville = $adrville;
    
        return $this;
    }

    /**
     * Get adrville
     *
     * @return string 
     */
    public function getAdrville()
    {
        return $this->adrville;
    }

    /**
     * Set adrcp
     *
     * @param string $adrcp
     * @return Banquescentre
     */
    public function setAdrcp($adrcp)
    {
        $this->adrcp = $adrcp;
    
        return $this;
    }

    /**
     * Get adrcp
     *
     * @return string 
     */
    public function getAdrcp()
    {
        return $this->adrcp;
    }

    /**
     * Set telephone
     *
     * @param string $telephone
     * @return Banquescentre
     */
    public function setTelephone($telephone)
    {
        $this->telephone = $telephone;
    
        return $this;
    }

    /**
     * Get telephone
     *
     * @return string 
     */
    public function getTelephone()
    {
        return $this->telephone;
    }

    /**
     * Set fax
     *
     * @param string $fax
     * @return Banquescentre
     */
    public function setFax($fax)
    {
        $this->fax = $fax;
    
        return $this;
    }

    /**
     * Get fax
     *
     * @return string 
     */
    public function getFax()
    {
        return $this->fax;
    }

    /**
     * Set email
     *
     * @param string $email
     * @return Banquescentre
     */
    public function setEmail($email)
    {
        $this->email = $email;
    
        return $this;
    }

    /**
     * Get email
     *
     * @return string 
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set adrvoie
     *
     * @param \alldevs\IfocopBundle\Entity\Voie $adrvoie
     * @return Banquescentre
     */
    public function setAdrvoie(\alldevs\IfocopBundle\Entity\Voie $adrvoie = null)
    {
        $this->adrvoie = $adrvoie;
    
        return $this;
    }

    /**
     * Get adrvoie
     *
     * @return \alldevs\IfocopBundle\Entity\Voie 
     */
    public function getAdrvoie()
    {
        return $this->adrvoie;
    }

    /**
     * Set idCentres
     *
     * @param \alldevs\IfocopBundle\Entity\Centres $idCentres
     * @return Banquescentre
     */
    public function setIdCentres(\alldevs\IfocopBundle\Entity\Centres $idCentres = null)
    {
        $this->idCentres = $idCentres;
    
        return $this;
    }

    /**
     * Get idCentres
     *
     * @return \alldevs\IfocopBundle\Entity\Centres 
     */
    public function getIdCentres()
    {
        return $this->idCentres;
    }

    /**
     * Set dombanque
     *
     * @param string $dombanque
     * @return Banquescentre
     */
    public function setDombanque($dombanque)
    {
        $this->dombanque = $dombanque;
    
        return $this;
    }

    /**
     * Get dombanque
     *
     * @return string 
     */
    public function getDombanque()
    {
        return $this->dombanque;
    }

    /**
     * Set numcompte
     *
     * @param string $numcompte
     * @return Banquescentre
     */
    public function setNumcompte($numcompte)
    {
        $this->numcompte = $numcompte;
    
        return $this;
    }

    /**
     * Get numcompte
     *
     * @return string 
     */
    public function getNumcompte()
    {
        return $this->numcompte;
    }

    /**
     * Set clerib
     *
     * @param string $clerib
     * @return Banquescentre
     */
    public function setClerib($clerib)
    {
        $this->clerib = $clerib;
    
        return $this;
    }

    /**
     * Get clerib
     *
     * @return string 
     */
    public function getClerib()
    {
        return $this->clerib;
    }

    /**
     * Set banquefacture
     *
     * @param boolean $banquefacture
     * @return Banquescentre
     */
    public function setBanquefacture($banquefacture)
    {
        $this->banquefacture = $banquefacture;
    
        return $this;
    }

    /**
     * Get banquefacture
     *
     * @return boolean 
     */
    public function getBanquefacture()
    {
        return $this->banquefacture;
    }

    /**
     * Set iban
     *
     * @param string $iban
     * @return Banquescentre
     */
    public function setIban($iban)
    {
        $this->iban = $iban;
    
        return $this;
    }

    /**
     * Get iban
     *
     * @return string 
     */
    public function getIban()
    {
        return $this->iban;
    }
}