<?php

namespace alldevs\IfocopBundle\Entity;

use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Centres
 *
 * @ORM\Table(name="centres")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\CentresRepository")
 */
class Centres
{
    /**
     * 
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * 
     * @ORM\Column(name="lib", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)   
     */
    private $lib;
    
    /**
     *   
     * @ORM\Column(name="adrrue", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $adrrue;

    /**
     *   
     * @ORM\Column(name="adrville", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $adrville;
    
    /**
     *      
     * @ORM\Column(name="adrcp", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(5)
     */
    private $adrcp;

    /**
     * @ORM\Column(name="telephone", type="string", length=20, nullable=true)
     * @Assert\MaxLength(30) 
     */
    private $telephone;
 
    /**
     * @ORM\Column(name="fax", type="string", length=20, nullable=true)
     * @Assert\MaxLength(30) 
     */
    private $fax;

    /**
     * @ORM\Column(name="email", type="string", length=100, nullable=true)
     * @Assert\MaxLength(30) 
     * @Assert\Email(
     *     message = "'{{ value }}' n'est pas un email valide."
     * ) 
     */
    private $email;
    
    /**
     * @ORM\Column(name="observation", type="text", nullable=true)
     */
    private $observation;
    
    /**
     * 
     * @ORM\Column(name="principal", type="boolean", nullable=true)
     */
    private $principal;
    
     /**
     * @ORM\OneToMany(targetEntity="Groupes", mappedBy="idCentres", cascade={"all"})
     */
    protected $idGroupes;

    /**
     * @ORM\OneToMany(targetEntity="Facture", mappedBy="idCentres", cascade={"all"})
     */
    protected $idFactures;
    
    /**
     *
     * @ORM\ManyToMany(targetEntity="Myuser", inversedBy="idCentres", cascade="persist")
     * @ORM\JoinTable(name="myuser_centre",
     * inverseJoinColumns={@ORM\JoinColumn(name="id_myuser", referencedColumnName="id")},
     * joinColumns={@ORM\JoinColumn(name="id_centres", referencedColumnName="id")}
     * )   
     * 
     */   
    private $idMyuser;
    
    
    public function __toString()
    {
            return $this->getLib().'';
    }


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set lib
     *
     * @param string $lib
     * @return Centres
     */
    public function setLib($lib)
    {
        $this->lib = $lib;
    
        return $this;
    }

    /**
     * Get lib
     *
     * @return string 
     */
    public function getLib()
    {
        return $this->lib;
    }

    /**
     * Set adrrue
     *
     * @param string $adrrue
     * @return Centres
     */
    public function setAdrrue($adrrue)
    {
        $this->adrrue = $adrrue;
    
        return $this;
    }

    /**
     * Get adrrue
     *
     * @return string 
     */
    public function getAdrrue()
    {
        return $this->adrrue;
    }

    /**
     * Set adrville
     *
     * @param string $adrville
     * @return Centres
     */
    public function setAdrville($adrville)
    {
        $this->adrville = $adrville;
    
        return $this;
    }

    /**
     * Get adrville
     *
     * @return string 
     */
    public function getAdrville()
    {
        return $this->adrville;
    }

    /**
     * Set adrcp
     *
     * @param string $adrcp
     * @return Centres
     */
    public function setAdrcp($adrcp)
    {
        $this->adrcp = $adrcp;
    
        return $this;
    }

    /**
     * Get adrcp
     *
     * @return string 
     */
    public function getAdrcp()
    {
        return $this->adrcp;
    }

    /**
     * Set telephone
     *
     * @param string $telephone
     * @return Centres
     */
    public function setTelephone($telephone)
    {
        $this->telephone = $telephone;
    
        return $this;
    }

    /**
     * Get telephone
     *
     * @return string 
     */
    public function getTelephone()
    {
        return $this->telephone;
    }

    /**
     * Set fax
     *
     * @param string $fax
     * @return Centres
     */
    public function setFax($fax)
    {
        $this->fax = $fax;
    
        return $this;
    }

    /**
     * Get fax
     *
     * @return string 
     */
    public function getFax()
    {
        return $this->fax;
    }

    /**
     * Set email
     *
     * @param string $email
     * @return Centres
     */
    public function setEmail($email)
    {
        $this->email = $email;
    
        return $this;
    }

    /**
     * Get email
     *
     * @return string 
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set observation
     *
     * @param string $observation
     * @return Centres
     */
    public function setObservation($observation)
    {
        $this->observation = $observation;
    
        return $this;
    }

    /**
     * Get observation
     *
     * @return string 
     */
    public function getObservation()
    {
        return $this->observation;
    }

    /**
     * Set adrvoie
     *
     * @param \alldevs\IfocopBundle\Entity\Voie $adrvoie
     * @return Centres
     */
    public function setAdrvoie(\alldevs\IfocopBundle\Entity\Voie $adrvoie = null)
    {
        $this->adrvoie = $adrvoie;
    
        return $this;
    }

    /**
     * Get adrvoie
     *
     * @return \alldevs\IfocopBundle\Entity\Voie 
     */
    public function getAdrvoie()
    {
        return $this->adrvoie;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idGroupes = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idGroupes
     *
     * @param \alldevs\IfocopBundle\Entity\Groupes $idGroupes
     * @return Centres
     */
    public function addIdGroupe(\alldevs\IfocopBundle\Entity\Groupes $idGroupes)
    {
        $this->idGroupes[] = $idGroupes;
    
        return $this;
    }

    /**
     * Remove idGroupes
     *
     * @param \alldevs\IfocopBundle\Entity\Groupes $idGroupes
     */
    public function removeIdGroupe(\alldevs\IfocopBundle\Entity\Groupes $idGroupes)
    {
        $this->idGroupes->removeElement($idGroupes);
    }

    /**
     * Get idGroupes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdGroupes()
    {
        return $this->idGroupes;
    }

    /**
     * Add idMyuser
     *
     * @param \alldevs\IfocopBundle\Entity\Myuser $idMyuser
     * @return Centres
     */
    public function addIdMyuser(\alldevs\IfocopBundle\Entity\Myuser $idMyuser)
    {
        $this->idMyuser[] = $idMyuser;
    
        return $this;
    }

    /**
     * Remove idMyuser
     *
     * @param \alldevs\IfocopBundle\Entity\Myuser $idMyuser
     */
    public function removeIdMyuser(\alldevs\IfocopBundle\Entity\Myuser $idMyuser)
    {
        $this->idMyuser->removeElement($idMyuser);
    }

    /**
     * Get idMyuser
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdMyuser()
    {
        return $this->idMyuser;
    }

    /**
     * Set principal
     *
     * @param boolean $principal
     * @return Centres
     */
    public function setPrincipal($principal)
    {
        $this->principal = $principal;
    
        return $this;
    }

    /**
     * Get principal
     *
     * @return boolean 
     */
    public function getPrincipal()
    {
        return $this->principal;
    }

    /**
     * Add idFactures
     *
     * @param \alldevs\IfocopBundle\Entity\Facture $idFactures
     * @return Centres
     */
    public function addIdFacture(\alldevs\IfocopBundle\Entity\Facture $idFactures)
    {
        $this->idFactures[] = $idFactures;
    
        return $this;
    }

    /**
     * Remove idFactures
     *
     * @param \alldevs\IfocopBundle\Entity\Facture $idFactures
     */
    public function removeIdFacture(\alldevs\IfocopBundle\Entity\Facture $idFactures)
    {
        $this->idFactures->removeElement($idFactures);
    }

    /**
     * Get idFactures
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdFactures()
    {
        return $this->idFactures;
    }
}