<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * DepotBanque
 * 
 * @ORM\Table(name="depotbanque")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\DepotBanqueRepository")
 */
class DepotBanque
{
    /**
     * 
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * 
     * @ORM\Column(name="banque", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(100)  
     */
    private $banque;

    /**
     * 
     * @ORM\Column(name="cdebanque", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(25)  
     */
    private $cdebanque;

    /**
     * 
     * @ORM\Column(name="cdageance", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(25) 
     */
    private $cdeagence;

    /**
     * @var integer
     */
    private $centre;

    /**
     * 
     * @ORM\Column(name="dateremise", type="datetime", nullable=true)
     */
    private $dateremise;

    /**
     * 
     * @ORM\Column(name="numremise", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(25) 
     */
    private $numremise;

    /**
     * 
     * @ORM\Column(name="numcompte", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(25) 
     */
    private $numcompte;

    /**
     * 
     * @ORM\Column(name="numcheque", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(25) 
     */
    private $numcheque;

    /**
     * 
     * @ORM\Column(name="titulaire", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(25) 
     */
    private $titulaire;

    /**
     * 
     * @ORM\Column(name="description", type="text", nullable=true)
     */
    private $description;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set banque
     *
     * @param string $banque
     * @return DepotBanque
     */
    public function setBanque($banque)
    {
        $this->banque = $banque;
    
        return $this;
    }

    /**
     * Get banque
     *
     * @return string 
     */
    public function getBanque()
    {
        return $this->banque;
    }

    /**
     * Set cdebanque
     *
     * @param string $cdebanque
     * @return DepotBanque
     */
    public function setCdebanque($cdebanque)
    {
        $this->cdebanque = $cdebanque;
    
        return $this;
    }

    /**
     * Get cdebanque
     *
     * @return string 
     */
    public function getCdebanque()
    {
        return $this->cdebanque;
    }

    /**
     * Set cdeagence
     *
     * @param string $cdeagence
     * @return DepotBanque
     */
    public function setCdeagence($cdeagence)
    {
        $this->cdeagence = $cdeagence;
    
        return $this;
    }

    /**
     * Get cdeagence
     *
     * @return string 
     */
    public function getCdeagence()
    {
        return $this->cdeagence;
    }

    /**
     * Set dateremise
     *
     * @param \DateTime $dateremise
     * @return DepotBanque
     */
    public function setDateremise($dateremise)
    {
        $this->dateremise = $dateremise;
    
        return $this;
    }

    /**
     * Get dateremise
     *
     * @return \DateTime 
     */
    public function getDateremise()
    {
        return $this->dateremise;
    }

    /**
     * Set numremise
     *
     * @param string $numremise
     * @return DepotBanque
     */
    public function setNumremise($numremise)
    {
        $this->numremise = $numremise;
    
        return $this;
    }

    /**
     * Get numremise
     *
     * @return string 
     */
    public function getNumremise()
    {
        return $this->numremise;
    }

    /**
     * Set numcompte
     *
     * @param string $numcompte
     * @return DepotBanque
     */
    public function setNumcompte($numcompte)
    {
        $this->numcompte = $numcompte;
    
        return $this;
    }

    /**
     * Get numcompte
     *
     * @return string 
     */
    public function getNumcompte()
    {
        return $this->numcompte;
    }

    /**
     * Set numcheque
     *
     * @param string $numcheque
     * @return DepotBanque
     */
    public function setNumcheque($numcheque)
    {
        $this->numcheque = $numcheque;
    
        return $this;
    }

    /**
     * Get numcheque
     *
     * @return string 
     */
    public function getNumcheque()
    {
        return $this->numcheque;
    }

    /**
     * Set titulaire
     *
     * @param string $titulaire
     * @return DepotBanque
     */
    public function setTitulaire($titulaire)
    {
        $this->titulaire = $titulaire;
    
        return $this;
    }

    /**
     * Get titulaire
     *
     * @return string 
     */
    public function getTitulaire()
    {
        return $this->titulaire;
    }

    /**
     * Set description
     *
     * @param string $description
     * @return DepotBanque
     */
    public function setDescription($description)
    {
        $this->description = $description;
    
        return $this;
    }

    /**
     * Get description
     *
     * @return string 
     */
    public function getDescription()
    {
        return $this->description;
    }
}