<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Facture
 *  
 * @ORM\Table(name="facture")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\FactureRepository")
 */
class Facture
{
    /**
     *     
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * 
     * @ORM\Column(name="numfacture", type="string", length=255, nullable=true)
     */
    private $numfacture;
    
    /**
     * 
     * @ORM\Column(name="reference", type="string", length=255, nullable=true)
     */
    private $reference;
    
    /**
     * 
     * @ORM\Column(name="vosrefs", type="string", length=255, nullable=true)
     */
    private $vosrefs;
    
    /**
     * @ORM\Column(name="montant", type="float", nullable=true)
     */
    private $montant;
    
    /**
     * 
     * @ORM\Column(name="nbreheure", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $nbreheure;
    
    /**
     * 
     * @ORM\Column(name="echeance", type="datetime", nullable=true)
     * @Assert\NotBlank()
     * @Assert\DateTime()
     */
    private $echeance;
    
    /**
     * 
     * @ORM\Column(name="datecreation", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $datecreation;

    /**
     * 
     * @ORM\Column(name="commentaire", type="text", nullable=true)
     */
    private $commentaire;
    

    /**
     * @var \Prises
     *
     * @ORM\ManyToOne(targetEntity="Prises", inversedBy="idFacture", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_prises", referencedColumnName="id")
     * })
     * @Assert\NotNull()
     */    
    private $idPrises;  
 
    /**
     * @var \Stagiaires
     *
     * @ORM\ManyToOne(targetEntity="Stagiaires", inversedBy="idFacture", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_stagiaires", referencedColumnName="id")
     * })
     * 
     */  
    private $idStagiaires; 
    
    /**
     * @var \Groupes
     *
     * @ORM\ManyToOne(targetEntity="Groupes", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_groupes", referencedColumnName="id")
     * })
     */  
    private $idGroupes;     
    
     
    /**
     * @var \Centres
     *
     * @ORM\ManyToOne(targetEntity="Centres", inversedBy="idFactures", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_centres", referencedColumnName="id")
     * })
     * 
     */  
    private $idCentres; 

    public function __toString()
    {
            return $this->getNumfacture();
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set numfacture
     *
     * @param string $numfacture
     * @return Facture
     */
    public function setNumfacture($numfacture)
    {
        $this->numfacture = $numfacture;
    
        return $this;
    }

    /**
     * Get numfacture
     *
     * @return string 
     */
    public function getNumfacture()
    {
        return $this->numfacture;
    }

    /**
     * Set reference
     *
     * @param string $reference
     * @return Facture
     */
    public function setReference($reference)
    {
        $this->reference = $reference;
    
        return $this;
    }

    /**
     * Get reference
     *
     * @return string 
     */
    public function getReference()
    {
        return $this->reference;
    }

    /**
     * Set vosrefs
     *
     * @param string $vosrefs
     * @return Facture
     */
    public function setVosrefs($vosrefs)
    {
        $this->vosrefs = $vosrefs;
    
        return $this;
    }

    /**
     * Get vosrefs
     *
     * @return string 
     */
    public function getVosrefs()
    {
        return $this->vosrefs;
    }

    /**
     * Set montant
     *
     * @param float $montant
     * @return Facture
     */
    public function setMontant($montant)
    {
        $this->montant = $montant;
    
        return $this;
    }

    /**
     * Get montant
     *
     * @return float 
     */
    public function getMontant()
    {
        return $this->montant;
    }

    /**
     * Set datecreation
     *
     * @param \DateTime $datecreation
     * @return Facture
     */
    public function setDatecreation($datecreation)
    {
        $this->datecreation = $datecreation;
    
        return $this;
    }

    /**
     * Get datecreation
     *
     * @return \DateTime 
     */
    public function getDatecreation()
    {
        return $this->datecreation;
    }

    /**
     * Set commentaire
     *
     * @param string $commentaire
     * @return Facture
     */
    public function setCommentaire($commentaire)
    {
        $this->commentaire = $commentaire;
    
        return $this;
    }

    /**
     * Get commentaire
     *
     * @return string 
     */
    public function getCommentaire()
    {
        return $this->commentaire;
    }

    /**
     * Set idPrises
     *
     * @param \alldevs\IfocopBundle\Entity\Prises $idPrises
     * @return Facture
     */
    public function setIdPrises(\alldevs\IfocopBundle\Entity\Prises $idPrises = null)
    {
        $this->idPrises = $idPrises;
    
        return $this;
    }

    /**
     * Get idPrises
     *
     * @return \alldevs\IfocopBundle\Entity\Prises 
     */
    public function getIdPrises()
    {
        return $this->idPrises;
    }

    /**
     * Set idStagiaires
     *
     * @param \alldevs\IfocopBundle\Entity\Stagiaires $idStagiaires
     * @return Facture
     */
    public function setIdStagiaires(\alldevs\IfocopBundle\Entity\Stagiaires $idStagiaires = null)
    {
        $this->idStagiaires = $idStagiaires;
    
        return $this;
    }

    /**
     * Get idStagiaires
     *
     * @return \alldevs\IfocopBundle\Entity\Stagiaires 
     */
    public function getIdStagiaires()
    {
        return $this->idStagiaires;
    }

    /**
     * Set idGroupes
     *
     * @param \alldevs\IfocopBundle\Entity\Groupes $idGroupes
     * @return Facture
     */
    public function setIdGroupes(\alldevs\IfocopBundle\Entity\Groupes $idGroupes = null)
    {
        $this->idGroupes = $idGroupes;
    
        return $this;
    }

    /**
     * Get idGroupes
     *
     * @return \alldevs\IfocopBundle\Entity\Groupes 
     */
    public function getIdGroupes()
    {
        return $this->idGroupes;
    }

    /**
     * Set nbreheure
     *
     * @param string $nbreheure
     * @return Facture
     */
    public function setNbreheure($nbreheure)
    {
        $this->nbreheure = $nbreheure;
    
        return $this;
    }

    /**
     * Get nbreheure
     *
     * @return string 
     */
    public function getNbreheure()
    {
        return $this->nbreheure;
    }

    /**
     * Set echeance
     *
     * @param \DateTime $echeance
     * @return Facture
     */
    public function setEcheance($echeance)
    {
        $this->echeance = $echeance;
    
        return $this;
    }

    /**
     * Get echeance
     *
     * @return \DateTime 
     */
    public function getEcheance()
    {
        return $this->echeance;
    }

    /**
     * Set idCentres
     *
     * @param \alldevs\IfocopBundle\Entity\Centres $idCentres
     * @return Facture
     */
    public function setIdCentres(\alldevs\IfocopBundle\Entity\Centres $idCentres = null)
    {
        $this->idCentres = $idCentres;
    
        return $this;
    }

    /**
     * Get idCentres
     *
     * @return \alldevs\IfocopBundle\Entity\Centres 
     */
    public function getIdCentres()
    {
        return $this->idCentres;
    }
}