<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Formation
 * 
 * @ORM\Table(name="formations")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\FormationsRepository")
 */
class Formations
{
    /**
     *      
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * 
     * @ORM\Column(name="lib", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)  
     */
    private $lib;
    
    /**
     *      
     * @ORM\Column(name="libabr", type="string", length=20, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(10)  
     */
    private $libabr;
    
    /**
     * 
     * @ORM\Column(name="opt", type="string", length=255, nullable=true)
     * @Assert\MaxLength(50)  
     */
    private $opt;

    /**
     *      
     * @ORM\Column(name="optabr", type="string", length=20, nullable=true)
     * @Assert\MaxLength(10)  
     */
    private $optabr;

    /**
     * 
     * @ORM\Column(name="description", type="text", nullable=true)
     */
    private $description;
 
    /**
     * @var float
     * @ORM\Column(name="tarif", type="float", nullable=false)
     */
    private $tarif;

    /**
     * @ORM\Column(name="droitinscr", type="float", nullable=true)
     */
    private $droitinscr;
    
    /**
     * 
     * @ORM\ManyToMany(targetEntity="Groupes", mappedBy="idFormations", cascade="persist")
     */   
    private $idGroupes;
 
    public function __toString()
    {
            return $this->getLib();
    }   

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idGroupes = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set lib
     *
     * @param string $lib
     * @return Formations
     */
    public function setLib($lib)
    {
        $this->lib = $lib;
    
        return $this;
    }

    /**
     * Get lib
     *
     * @return string 
     */
    public function getLib()
    {
        return $this->lib;
    }

    /**
     * Set libabr
     *
     * @param string $libabr
     * @return Formations
     */
    public function setLibabr($libabr)
    {
        $this->libabr = $libabr;
    
        return $this;
    }

    /**
     * Get libabr
     *
     * @return string 
     */
    public function getLibabr()
    {
        return $this->libabr;
    }

    /**
     * Set opt
     *
     * @param string $opt
     * @return Formations
     */
    public function setOpt($opt)
    {
        $this->opt = $opt;
    
        return $this;
    }

    /**
     * Get opt
     *
     * @return string 
     */
    public function getOpt()
    {
        return $this->opt;
    }

    /**
     * Set optabr
     *
     * @param string $optabr
     * @return Formations
     */
    public function setOptabr($optabr)
    {
        $this->optabr = $optabr;
    
        return $this;
    }

    /**
     * Get optabr
     *
     * @return string 
     */
    public function getOptabr()
    {
        return $this->optabr;
    }

    /**
     * Set description
     *
     * @param string $description
     * @return Formations
     */
    public function setDescription($description)
    {
        $this->description = $description;
    
        return $this;
    }

    /**
     * Get description
     *
     * @return string 
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Set tarif
     *
     * @param float $tarif
     * @return Formations
     */
    public function setTarif($tarif)
    {
        $this->tarif = $tarif;
    
        return $this;
    }

    /**
     * Get tarif
     *
     * @return float 
     */
    public function getTarif()
    {
        return $this->tarif;
    }

    /**
     * Set droitinscr
     *
     * @param float $droitinscr
     * @return Formations
     */
    public function setDroitinscr($droitinscr)
    {
        $this->droitinscr = $droitinscr;
    
        return $this;
    }

    /**
     * Get droitinscr
     *
     * @return float 
     */
    public function getDroitinscr()
    {
        return $this->droitinscr;
    }

    /**
     * Add idGroupes
     *
     * @param \alldevs\IfocopBundle\Entity\Groupes $idGroupes
     * @return Formations
     */
    public function addIdGroupe(\alldevs\IfocopBundle\Entity\Groupes $idGroupes)
    {
        $this->idGroupes[] = $idGroupes;
    
        return $this;
    }

    /**
     * Remove idGroupes
     *
     * @param \alldevs\IfocopBundle\Entity\Groupes $idGroupes
     */
    public function removeIdGroupe(\alldevs\IfocopBundle\Entity\Groupes $idGroupes)
    {
        $this->idGroupes->removeElement($idGroupes);
    }

    /**
     * Get idGroupes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdGroupes()
    {
        return $this->idGroupes;
    }
}