<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Organismes
 * 
 * @ORM\Table(name="organismes")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\OrganismesRepository")
 */
class Organismes
{
    /**
     *     
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     *  
     * @ORM\Column(name="lib", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(75)  
     */
    private $lib;
    
    /**
     *   
     * @ORM\Column(name="libcomp", type="string", length=255, nullable=true)
     * 
     */
    private $libcomp;
    
    /**
     *   
     * @ORM\Column(name="adrrue", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $adrrue;

    /**
     *   
     * @ORM\Column(name="adrville", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $adrville;

    /**
     *      
     * @ORM\Column(name="adrcp", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(5)
     */
    private $adrcp;
    
    /**
     *      
     * @ORM\Column(name="adrbp", type="string", length=255, nullable=true)
     *        
     */
    private $adrbp;
    
    /**
     * 
     * @ORM\Column(name="telephone", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $telephone;

    /**
     * 
     * @ORM\Column(name="fax", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $fax;

    /**
     * 
     * @ORM\Column(name="email", type="string", length=100, nullable=true)
     * @Assert\MaxLength(70) 
     * @Assert\Email(
     *     message = "'{{ value }}' n'est pas un email valide."
     * ) 
     */
    private $email;

    /**
     * 
     * @ORM\Column(name="description", type="text", nullable=true)
     */
    private $description;
    
    /**
     * 
     * @ORM\Column(name="reference", type="string", length=255, nullable=true)
     * @Assert\MaxLength(255) 
     */
    private $reference;
    
    /**
     * @ORM\OneToMany(targetEntity="Prises", mappedBy="idOrganismes", cascade={"remove", "persist"})
     */
    protected $idPrises;
    
    public function __toString()
    {
            return $this->getLib();
    }
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set lib
     *
     * @param string $lib
     * @return Organismes
     */
    public function setLib($lib)
    {
        $this->lib = $lib;
    
        return $this;
    }

    /**
     * Get lib
     *
     * @return string 
     */
    public function getLib()
    {
        return $this->lib;
    }

    /**
     * Set adrrue
     *
     * @param string $adrrue
     * @return Organismes
     */
    public function setAdrrue($adrrue)
    {
        $this->adrrue = $adrrue;
    
        return $this;
    }

    /**
     * Get adrrue
     *
     * @return string 
     */
    public function getAdrrue()
    {
        return $this->adrrue;
    }

    /**
     * Set adrville
     *
     * @param string $adrville
     * @return Organismes
     */
    public function setAdrville($adrville)
    {
        $this->adrville = $adrville;
    
        return $this;
    }

    /**
     * Get adrville
     *
     * @return string 
     */
    public function getAdrville()
    {
        return $this->adrville;
    }

    /**
     * Set adrcp
     *
     * @param string $adrcp
     * @return Organismes
     */
    public function setAdrcp($adrcp)
    {
        $this->adrcp = $adrcp;
    
        return $this;
    }

    /**
     * Get adrcp
     *
     * @return string 
     */
    public function getAdrcp()
    {
        return $this->adrcp;
    }

    /**
     * Set telephone
     *
     * @param string $telephone
     * @return Organismes
     */
    public function setTelephone($telephone)
    {
        $this->telephone = $telephone;
    
        return $this;
    }

    /**
     * Get telephone
     *
     * @return string 
     */
    public function getTelephone()
    {
        return $this->telephone;
    }

    /**
     * Set fax
     *
     * @param string $fax
     * @return Organismes
     */
    public function setFax($fax)
    {
        $this->fax = $fax;
    
        return $this;
    }

    /**
     * Get fax
     *
     * @return string 
     */
    public function getFax()
    {
        return $this->fax;
    }

    /**
     * Set email
     *
     * @param string $email
     * @return Organismes
     */
    public function setEmail($email)
    {
        $this->email = $email;
    
        return $this;
    }

    /**
     * Get email
     *
     * @return string 
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set description
     *
     * @param string $description
     * @return Organismes
     */
    public function setDescription($description)
    {
        $this->description = $description;
    
        return $this;
    }

    /**
     * Get description
     *
     * @return string 
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Set adrvoie
     *
     * @param \alldevs\IfocopBundle\Entity\Voie $adrvoie
     * @return Organismes
     */
    public function setAdrvoie(\alldevs\IfocopBundle\Entity\Voie $adrvoie = null)
    {
        $this->adrvoie = $adrvoie;
    
        return $this;
    }

    /**
     * Get adrvoie
     *
     * @return \alldevs\IfocopBundle\Entity\Voie 
     */
    public function getAdrvoie()
    {
        return $this->adrvoie;
    }

    /**
     * Add idPrises
     *
     * @param \alldevs\IfocopBundle\Entity\Prises $idPrises
     * @return Organismes
     */
    public function addIdPrise(\alldevs\IfocopBundle\Entity\Prises $idPrises)
    {
        $this->idPrises[] = $idPrises;
    
        return $this;
    }

    /**
     * Remove idPrises
     *
     * @param \alldevs\IfocopBundle\Entity\Prises $idPrises
     */
    public function removeIdPrise(\alldevs\IfocopBundle\Entity\Prises $idPrises)
    {
        $this->idPrises->removeElement($idPrises);
    }

    /**
     * Get idPrises
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdPrises()
    {
        return $this->idPrises;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idPrises = new \Doctrine\Common\Collections\ArrayCollection();
    }
    

    /**
     * Set reference
     *
     * @param string $reference
     * @return Organismes
     */
    public function setReference($reference)
    {
        $this->reference = $reference;
    
        return $this;
    }

    /**
     * Get reference
     *
     * @return string 
     */
    public function getReference()
    {
        return $this->reference;
    }

    /**
     * Set adrbp
     *
     * @param string $adrbp
     * @return Organismes
     */
    public function setAdrbp($adrbp)
    {
        $this->adrbp = $adrbp;
    
        return $this;
    }

    /**
     * Get adrbp
     *
     * @return string 
     */
    public function getAdrbp()
    {
        return $this->adrbp;
    }

    /**
     * Set libcomp
     *
     * @param string $libcomp
     * @return Organismes
     */
    public function setLibcomp($libcomp)
    {
        $this->libcomp = $libcomp;
    
        return $this;
    }

    /**
     * Get libcomp
     *
     * @return string 
     */
    public function getLibcomp()
    {
        return $this->libcomp;
    }
}