<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Reglement
 *  
 * @ORM\Table(name="reglement")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\ReglementRepository")
 */
class Reglement
{
    /**
     *     
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;
    
    /**
     * 
     * @ORM\Column(name="lib", type="string", length=255, nullable=true)
     */
    private $lib;
    
    /**
     * 
     * @ORM\ManyToOne(targetEntity="Modalite")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_modalite", referencedColumnName="id")
     * })
     * @Assert\NotNull() 
     */
    private $idModalite;
    
    /**
     * 
     * @ORM\ManyToOne(targetEntity="Banquescentre")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_banques", referencedColumnName="id")
     * })
     */
    private $idBanques;
    
    /**
     * 
     * @ORM\Column(name="reference", type="string", length=255, nullable=true)
     */
    private $reference;

    /**
     * @ORM\Column(name="montant", type="float", nullable=false)
     * @Assert\NotBlank()
     */
    private $montant;

    /**
     * 
     * @ORM\Column(name="datereception", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $datereception;

    /**
     * 
     * @ORM\Column(name="dateremise", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dateremise;   

    /**
     * 
     * @ORM\Column(name="tireur", type="string", length=255, nullable=true)
     */
    private $tireur;

    /**
     * 
     * @ORM\Column(name="numremise", type="string", length=255, nullable=true)
     */
    private $numremise;
    
    /**
     * 
     * @ORM\Column(name="numcomptecs", type="string", length=255, nullable=true)
     * @Assert\MaxLength(25) 
     */
    private $numcomptecs;
    
    /**
     * 
     * @ORM\Column(name="numcomptedi", type="string", length=255, nullable=true)
     * @Assert\MaxLength(25) 
     */
    private $numcomptedi;
    
    /**
     * 
     * @ORM\Column(name="banquetireur", type="string", length=255, nullable=true)
     * @Assert\MaxLength(255) 
     */
    private $banquetireur;
    
    /**
     * 
     * @ORM\Column(name="numcheque", type="string", length=255, nullable=true)
     * @Assert\MaxLength(25) 
     */
    private $numcheque;
    
    /**
     * 
     * @ORM\Column(name="rmbcs", type="float", nullable=true) 
     */
    private $rmbcs;

    /**
     * 
     * @ORM\Column(name="rmbdi", type="float", nullable=true)
     */
    private $rmbdi;

    /**
     * 
     * @ORM\Column(name="typecompte", type="integer", nullable=false)
     */
    private $typecompte;
    
    /**
     * 
     * @ORM\Column(name="validation", type="boolean", nullable=true)
     */
    private $validation;

    /**
     * 
     * @ORM\Column(name="commentaire", type="text", nullable=true)
     */
    private $commentaire;
    

    /**
     * @var \Prises
     *
     * @ORM\ManyToOne(targetEntity="Prises", inversedBy="idReglement", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_prises", referencedColumnName="id")
     * })
     */    
    private $idPrises;  
 
    /**
     * @var \Stagiaires
     *
     * @ORM\ManyToOne(targetEntity="Stagiaires", inversedBy="idReglement", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_stagiaires", referencedColumnName="id")
     * })
     */  
    private $idStagiaires; 
    
    /**
     *
     * @ORM\Column(name="id_groupes", type="integer", nullable=true)
     * 
     */
    private $id_groupes; 
    
    /**
     * @ORM\Column(name="observation", type="text", nullable=true)
     */
    private $observation;
    
    public function __toString()
    {
            return $this->getLib();
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set lib
     *
     * @param string $lib
     * @return Reglement
     */
    public function setLib($lib)
    {
        $this->lib = $lib;
    
        return $this;
    }

    /**
     * Get lib
     *
     * @return string 
     */
    public function getLib()
    {
        return $this->lib;
    }

    /**
     * Set reference
     *
     * @param string $reference
     * @return Reglement
     */
    public function setReference($reference)
    {
        $this->reference = $reference;
    
        return $this;
    }

    /**
     * Get reference
     *
     * @return string 
     */
    public function getReference()
    {
        return $this->reference;
    }

    /**
     * Set montant
     *
     * @param float $montant
     * @return Reglement
     */
    public function setMontant($montant)
    {
        $this->montant = $montant;
    
        return $this;
    }

    /**
     * Get montant
     *
     * @return float 
     */
    public function getMontant()
    {
        return $this->montant;
    }

    /**
     * Set datereception
     *
     * @param \DateTime $datereception
     * @return Reglement
     */
    public function setDatereception($datereception)
    {
        $this->datereception = $datereception;
    
        return $this;
    }

    /**
     * Get datereception
     *
     * @return \DateTime 
     */
    public function getDatereception()
    {
        return $this->datereception;
    }

    /**
     * Set dateremise
     *
     * @param \DateTime $dateremise
     * @return Reglement
     */
    public function setDateremise($dateremise)
    {
        $this->dateremise = $dateremise;
    
        return $this;
    }

    /**
     * Get dateremise
     *
     * @return \DateTime 
     */
    public function getDateremise()
    {
        return $this->dateremise;
    }

    /**
     * Set tireur
     *
     * @param string $tireur
     * @return Reglement
     */
    public function setTireur($tireur)
    {
        $this->tireur = $tireur;
    
        return $this;
    }

    /**
     * Get tireur
     *
     * @return string 
     */
    public function getTireur()
    {
        return $this->tireur;
    }

    /**
     * Set numremise
     *
     * @param string $numremise
     * @return Reglement
     */
    public function setNumremise($numremise)
    {
        $this->numremise = $numremise;
    
        return $this;
    }

    /**
     * Get numremise
     *
     * @return string 
     */
    public function getNumremise()
    {
        return $this->numremise;
    }

    /**
     * Set numcomptecs
     *
     * @param string $numcomptecs
     * @return Reglement
     */
    public function setNumcomptecs($numcomptecs)
    {
        $this->numcomptecs = $numcomptecs;
    
        return $this;
    }

    /**
     * Get numcomptecs
     *
     * @return string 
     */
    public function getNumcomptecs()
    {
        return $this->numcomptecs;
    }

    /**
     * Set numcomptedi
     *
     * @param string $numcomptedi
     * @return Reglement
     */
    public function setNumcomptedi($numcomptedi)
    {
        $this->numcomptedi = $numcomptedi;
    
        return $this;
    }

    /**
     * Get numcomptedi
     *
     * @return string 
     */
    public function getNumcomptedi()
    {
        return $this->numcomptedi;
    }

    /**
     * Set banquetireur
     *
     * @param string $banquetireur
     * @return Reglement
     */
    public function setBanquetireur($banquetireur)
    {
        $this->banquetireur = $banquetireur;
    
        return $this;
    }

    /**
     * Get banquetireur
     *
     * @return string 
     */
    public function getBanquetireur()
    {
        return $this->banquetireur;
    }

    /**
     * Set numcheque
     *
     * @param string $numcheque
     * @return Reglement
     */
    public function setNumcheque($numcheque)
    {
        $this->numcheque = $numcheque;
    
        return $this;
    }

    /**
     * Get numcheque
     *
     * @return string 
     */
    public function getNumcheque()
    {
        return $this->numcheque;
    }

    /**
     * Set rmbcs
     *
     * @param float $rmbcs
     * @return Reglement
     */
    public function setRmbcs($rmbcs)
    {
        $this->rmbcs = $rmbcs;
    
        return $this;
    }

    /**
     * Get rmbcs
     *
     * @return float 
     */
    public function getRmbcs()
    {
        return $this->rmbcs;
    }

    /**
     * Set rmbdi
     *
     * @param float $rmbdi
     * @return Reglement
     */
    public function setRmbdi($rmbdi)
    {
        $this->rmbdi = $rmbdi;
    
        return $this;
    }

    /**
     * Get rmbdi
     *
     * @return float 
     */
    public function getRmbdi()
    {
        return $this->rmbdi;
    }

    /**
     * Set validation
     *
     * @param boolean $validation
     * @return Reglement
     */
    public function setValidation($validation)
    {
        $this->validation = $validation;
    
        return $this;
    }

    /**
     * Get validation
     *
     * @return boolean 
     */
    public function getValidation()
    {
        return $this->validation;
    }

    /**
     * Set commentaire
     *
     * @param string $commentaire
     * @return Reglement
     */
    public function setCommentaire($commentaire)
    {
        $this->commentaire = $commentaire;
    
        return $this;
    }

    /**
     * Get commentaire
     *
     * @return string 
     */
    public function getCommentaire()
    {
        return $this->commentaire;
    }

    /**
     * Set observation
     *
     * @param string $observation
     * @return Reglement
     */
    public function setObservation($observation)
    {
        $this->observation = $observation;
    
        return $this;
    }

    /**
     * Get observation
     *
     * @return string 
     */
    public function getObservation()
    {
        return $this->observation;
    }

    /**
     * Set idModalite
     *
     * @param \alldevs\IfocopBundle\Entity\Modalite $idModalite
     * @return Reglement
     */
    public function setIdModalite(\alldevs\IfocopBundle\Entity\Modalite $idModalite = null)
    {
        $this->idModalite = $idModalite;
    
        return $this;
    }

    /**
     * Get idModalite
     *
     * @return \alldevs\IfocopBundle\Entity\Modalite 
     */
    public function getIdModalite()
    {
        return $this->idModalite;
    }

    /**
     * Set idBanques
     *
     * @param \alldevs\IfocopBundle\Entity\Banquescentre $idBanques
     * @return Reglement
     */
    public function setIdBanques(\alldevs\IfocopBundle\Entity\Banquescentre $idBanques = null)
    {
        $this->idBanques = $idBanques;
    
        return $this;
    }

    /**
     * Get idBanques
     *
     * @return \alldevs\IfocopBundle\Entity\Banquescentre 
     */
    public function getIdBanques()
    {
        return $this->idBanques;
    }

    /**
     * Set idPrises
     *
     * @param \alldevs\IfocopBundle\Entity\Prises $idPrises
     * @return Reglement
     */
    public function setIdPrises(\alldevs\IfocopBundle\Entity\Prises $idPrises = null)
    {
        $this->idPrises = $idPrises;
    
        return $this;
    }

    /**
     * Get idPrises
     *
     * @return \alldevs\IfocopBundle\Entity\Prises 
     */
    public function getIdPrises()
    {
        return $this->idPrises;
    }

    /**
     * Set idStagiaires
     *
     * @param \alldevs\IfocopBundle\Entity\Stagiaires $idStagiaires
     * @return Reglement
     */
    public function setIdStagiaires(\alldevs\IfocopBundle\Entity\Stagiaires $idStagiaires = null)
    {
        $this->idStagiaires = $idStagiaires;
    
        return $this;
    }

    /**
     * Get idStagiaires
     *
     * @return \alldevs\IfocopBundle\Entity\Stagiaires 
     */
    public function getIdStagiaires()
    {
        return $this->idStagiaires;
    }

    /**
     * Set typecompte
     *
     * @param integer $typecompte
     * @return Reglement
     */
    public function setTypecompte($typecompte)
    {
        $this->typecompte = $typecompte;
    
        return $this;
    }

    /**
     * Get typecompte
     *
     * @return integer 
     */
    public function getTypecompte()
    {
        return $this->typecompte;
    }

    /**
     * Set id_groupes
     *
     * @param integer $idGroupes
     * @return Reglement
     */
    public function setIdGroupes($idGroupes)
    {
        $this->id_groupes = $idGroupes;
    
        return $this;
    }

    /**
     * Get id_groupes
     *
     * @return integer 
     */
    public function getIdGroupes()
    {
        return $this->id_groupes;
    }
}