<?
namespace alldevs\IfocopBundle\Form\Type\Synthese;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Doctrine\ORM\EntityRepository;
use Symfony\Component\HttpFoundation\Session\Session as Session;

class SyntheseSearchType extends AbstractType
{
    private $groupid;
    private $centreid;
    private $secucontext;
    
    public function __construct($groupid,$centreid,$secucontext){
        $this->groupid = $groupid;
        $this->centreid=$centreid;
        $this->secucontext=$secucontext;
    }
    
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $user=$this->secucontext->getToken()->getUser();       
          $centreid=$this->centreid;
          $groupid=$this->groupid;
 
          $builder->add('groupes', 'entity', array( 'class' => 'alldevsIfocopBundle:Groupes', 'query_builder' => function(EntityRepository $er) use($centreid)  {
               $q=$er->createQueryBuilder('u')->orderBy('u.lib', 'ASC');
               if ($centreid!="")
                   $q->innerJoin('u.idCentres','c')->andWhere("c.id=".$centreid);
               return $q;
          
               }, 'required' => false,  'label' => 'Groupes'));
           $builder->add('stagiaires', 'entity', array( 'class' => 'alldevsIfocopBundle:Stagiaires', 'query_builder' => function(EntityRepository $er) use($groupid, $centreid)  {
               $q=$er->createQueryBuilder('u')->orderBy('u.nom', 'ASC');
                   $q->innerJoin('u.idGroupes','c');
                   $q->innerJoin('c.idCentres','d');
               if ($groupid!="")
                   $q->andWhere("c.id=".$groupid);
               if ($centreid!="")
                   $q->andWhere("d.id=".$centreid);
               return $q;
               
               }, 'required' => false,  'label' => 'Stagiaires'));         
        
        if(!$this->secucontext->isGranted('ROLE_CENTRE'))  
        {    
           $builder->add('centres', 'entity', array(  'class' => 'alldevsIfocopBundle:Centres', 'query_builder' => function(EntityRepository $er){

               return $er->createQueryBuilder('u')->orderBy('u.lib', 'ASC');
               
               }, 'required' => false,  'label' => 'Centres'));
   
           $builder->add('datedebut', 'datepicker', array(  'required' => false,  'label' => 'Date début'));           
           $builder->add('datefin', 'datepicker', array(  'required' => false,  'label' => 'Date fin')); 
           $builder->add('valid', 'checkbox', array(  'required' => false,  'label' => 'Avec règlements validés'));            
        }
        else
        {
            $builder->add('annee', 'text', array(  'required' => false,  'label' => 'Année'));            
        }
        
        $builder->add('negatif', 'checkbox', array(  'required' => false,  'label' => 'Solde négatif'));   
    }

    
   
               
    public function getName()
    {
        return 'synthese_search';
    }
}

?>